package com.tfg.api.projecte_tfg.builder;

import com.tfg.api.projecte_tfg.enums.Action;
import com.tfg.api.projecte_tfg.model.*;
import com.tfg.api.projecte_tfg.rest.object.CommentaryTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.service.CommentaryService;
import com.tfg.api.projecte_tfg.service.InfoUserService;
import com.tfg.api.projecte_tfg.service.LikePostService;
import com.tfg.api.projecte_tfg.util.DateUtils;
import com.tfg.api.projecte_tfg.util.StringUtils;

import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by marc on 10/05/14.
 */
@Stateless
@LocalBean
public class CommentaryBuilder {

    @EJB
    private CommentaryService commentaryService;
    @EJB
    private LikePostService likePostService;
    @EJB
    private InfoUserService ius;



    public CommentaryTO createError(String s) {
        return new CommentaryTO(ModelJSON.ERROR,s,null,null,null,null,null,null,null,null,null,null,null);
    }

    public CommentaryTO create(Commentary commentary,Long currentId) {

        byte[] imgeUser = null;
        if(commentary == null){return createError("commentary null");}
        String name = "";
        Action action = Action.NOTHING;
        Long id = null;

        String userName = commentary.getUser() == null ? "":commentary.getUser().getNom() +" "+
                commentary.getUser().getCognoms();

        String grupName = commentary.getGrup() == null ? "":commentary.getGrup().getNom();

        if(StringUtils.notEmptyChar(userName)){
            name = userName;
            action = Action.USER;

            User u = commentary.getUser();
            if(u != null){
                id = u.getId();
            }

            InfoUser iu = ius.getByIdUser(id);
            if( iu != null && iu.getImage() != null
                    && iu.getImage().getImagen() != null){
                imgeUser = iu.getImage().getImagen();
            }


        }else if(StringUtils.notEmptyChar(grupName)){
            name = grupName;
            action = Action.GRUP;
            id = commentary.getGrup().getId();
            imgeUser = commentary.getGrup().getImage().getImagen();
        }

        Long nLike = likePostService.countByCommentaryId(commentary.getId());
        nLike = nLike == null ? 0 : nLike;
        LikePost likePost = currentId == null ? null :  likePostService.matchCommentary(commentary.getId(),currentId);
        Boolean like = likePost == null ? false : likePost.getLike();



        return new CommentaryTO(ModelJSON.OK,ModelJSON.MSG_EMPTY,currentId,
                commentary.getId(),commentary.getPost().getId(),
                commentary.getText(), DateUtils.DateDecorator(commentary.getCreatedAt()),
                imgeUser,name,action,id,nLike,like);
    }

    public List<CommentaryTO> ListCommentaryTO(Post p, Long currentId) {

        List<Commentary> commentaryList = commentaryService.getAllByPostId(p.getId());

        if(commentaryList != null){

            List<CommentaryTO> commentaryTOList = new ArrayList<CommentaryTO>(commentaryList.size());
            for(Commentary commentary : commentaryList){

                commentaryTOList.add(create(commentary,currentId));
            }

            return commentaryTOList;
        }

        return null;
    }
}
