package com.tfg.api.projecte_tfg.builder;

import com.tfg.api.projecte_tfg.enums.Action;
import com.tfg.api.projecte_tfg.model.EventGrup;
import com.tfg.api.projecte_tfg.rest.object.EventTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.service.EventGrupService;
import com.tfg.api.projecte_tfg.util.DateUtils;

import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by marc on 08/05/14.
 */
@Stateless
@LocalBean
public class EventGrupBuilder {

    @EJB
    private EventGrupService eventGrupService;

    public EventTO createError(String s) {

        return new EventTO(ModelJSON.ERROR,s,null,null,null,null,null,null,null);
    }

    public EventTO create(EventGrup eventGrup,Long idcurrent) {

        if(eventGrup == null){
            return null;
        }

        String description = eventGrup.getDescription();
        String date = DateUtils.DateDecoratorInverse(eventGrup.getDate());
        String place = eventGrup.getPlace() == null ? "": eventGrup.getPlace().getName();
        String grupName = eventGrup.getGrup().getNom();
        Long grupId = eventGrup.getGrup().getId();
        return new EventTO(idcurrent,description,date,place,grupName,grupId, Action.EVENT);
    }

    private List<EventTO> makeListEventTO(Long id, Long grupId) {
        List<EventGrup> eventGrupList = eventGrupService.getActiveEventsTop10ByGrupId(grupId);
        List<EventTO> eventTOList = null;
        if(eventGrupList != null){
            eventTOList = new ArrayList<EventTO>(eventGrupList.size());

            for (EventGrup e : eventGrupList){
                eventTOList.add(create(e,id));
            }
        }
        return eventTOList;
    }
}
