package com.tfg.api.projecte_tfg.builder;

import com.tfg.api.projecte_tfg.enums.Relation;
import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.Friend;
import com.tfg.api.projecte_tfg.model.User;
import com.tfg.api.projecte_tfg.rest.object.FriendTO;
import com.tfg.api.projecte_tfg.rest.object.ListTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.service.FriendService;
import com.tfg.api.projecte_tfg.service.UserService;

import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by marc on 02/04/14.
 */

@Stateless
@LocalBean
public class FriendBuilder {

    @EJB
    UserService userService;

    @EJB
    private FriendService friendService;

    public FriendTO createObject(Friend f,Long currentId,Long user1Id,Long user2Id) throws Exception {

        Relation relation = null;

        if(f == null){
            if(user1Id.equals(user2Id)){
                relation = Relation.OWN;
            }else{
                relation = Relation.NO_FRIEND;
            }
        }else{
            if(f.getStatus() == Status.PENDING){
                relation = Relation.PENDING;
            }else if(f.getStatus() == Status.OK){
                relation = Relation.FRIEND;
            }else if(f.getStatus() == Status.NO){
                relation = Relation.NO_FRIEND;
            }
        }
        return new FriendTO(currentId,userService.getUser(user1Id),relation,userService.getUser(user2Id));
    }

    public Friend crearFriend(Long user1Id, Long user2Id) throws Exception {

        try{
            User u1 = userService.getUser(user1Id);
            User u2 = userService.getUser(user2Id);
            Status s = Status.OK;

            Friend f = new Friend(u1,u2,s);
            return f;
        }catch (Exception e){
            return null;
        }

    }

    public Relation friend(Long id, Long idUser) throws Exception {

        try{

            Friend f = friendService.match(id,idUser);

            if((f == null && id.equals(idUser))){
                return Relation.OWN;
            }else if(f == null){
                return Relation.NO_FRIEND;
            }else if (f != null && f.getStatus().equals(Status.OK)){ //FRIEND
                return Relation.FRIEND;
            }else{
                return Relation.NO_FRIEND;
            }

        }catch (Exception e){
            return Relation.NO_FRIEND;
        }

    }

    public ListTO<FriendTO> createListTO(List<Friend> list, Long currentId) throws Exception {

        if(list == null){
            return null;
        }

        ListTO listTO = new ListTO(currentId);

        List<FriendTO> friendTOList = new ArrayList<FriendTO>(list.size());

        for(Friend f : list){
            friendTOList.add(createObject(f,currentId,f.getUser1().getId(),f.getUser2().getId()));
        }

        listTO.setList(friendTOList);
        return listTO;

    }
}
