package com.tfg.api.projecte_tfg.builder;

import com.tfg.api.projecte_tfg.enums.Action;
import com.tfg.api.projecte_tfg.enums.Permit;
import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.enums.TypePost;
import com.tfg.api.projecte_tfg.model.*;
import com.tfg.api.projecte_tfg.rest.object.*;
import com.tfg.api.projecte_tfg.service.*;
import com.tfg.api.projecte_tfg.util.DateUtils;

import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Created by marc on 26/03/14.
 */

@Stateless
@LocalBean
public class PostBuilder {

    @EJB
    private UserBuilder userBuilder;
    @EJB
    private GrupBuilder grupBuilder;
    @EJB
    private Grup_UserService grup_userService;
    @EJB
    private CommentaryService commentaryService;
    @EJB
    private CommentaryBuilder commentaryBuilder;
    @EJB
    private LikePostService likePostService;
    @EJB
    private SouncloudBuilder souncloudBuilder;
    @EJB
    private FriendService friendService;
    @EJB
    private FollowGrupService followGrupService;

    public PostTO createError(String s) {
        return new PostTO(ModelJSON.ERROR, ModelJSON.MSG_EMPTY,null,null,null
                ,null,null,null,null,null,null,null,null,null,null,null,null);
    }

    public PostTO createOKNull(Long idcurrent){
        return new PostTO(ModelJSON.OK, ModelJSON.MSG_EMPTY,idcurrent, null, null,
                null,null, null,null,null,null,null,null,null,null,null,null);
    }


    public PostTO createPostTO(Post p,Long idcurrent){

        if(p != null){
            String date = DateUtils.DateDecorator(p.getCreatedAt());
            Permit permit = getPertmit(p,idcurrent);

            List<CommentaryTO> commentaryTOList = commentaryBuilder.ListCommentaryTO(p,idcurrent);

            Long nLike = likePostService.countByPostId(p.getId());
            nLike = nLike == null ? 0 : nLike;
            LikePost likePost = idcurrent == null ? null :  likePostService.matchPost(p.getId(),idcurrent);
            Boolean like = likePost == null ? false : likePost.getLike();

            SCTrackTO scTrackTO =  souncloudBuilder.createSCTrackTO(p.getScTrack());

            UserTO userTO = userBuilder.createUserTOSimple(p.getUser_to(), idcurrent);
            GrupTO grupTo = grupBuilder.createTOSimple(p.getGrup_to(), idcurrent, null, null);
            UserTO userFrom = userBuilder.createUserTO(p.getUser_from(),idcurrent);
            GrupTO grupFrom = grupBuilder.createTO(p.getGrup_from(),idcurrent,null,null);

            PostTO postTO = new PostTO(ModelJSON.OK, ModelJSON.MSG_EMPTY,idcurrent,
                p.getId(), p.getText(),DateUtils.DateDecorator(p.getCreatedAt()),
                userTO, grupTo,
                userFrom, grupFrom,
                createPostTO(firstPost(p),idcurrent),permit,commentaryTOList,nLike,like, Action.POST,scTrackTO);

        return postTO;

        }

        return null;
    }

    private Permit getPertmit(Post p, Long currentId) {

        if(p.getGrup_from() != null){

            GrupMember grupMember = grup_userService.match(p.getGrup_from().getId(),currentId);

            if(grupMember != null &&
                    Status.OK.equals(grupMember.getStatus().OK)){
                return Permit.RWS;
            }else{

                FollowGrup follow = followGrupService.match(currentId, p.getGrup_from().getId());

                if(follow != null && follow.getFollow()){
                    return Permit.RWS;
                }else{
                    return Permit.R__;
                }
            }
        }

        if(p.getUser_from() != null){

            if(p.getUser_from().getId().equals(currentId)){
                return Permit.RWS;
            }else{

                Friend friend = friendService.match(currentId, p.getUser_from().getId());

                if(friend != null && friend.getStatus().equals(Status.OK)){
                    return Permit.RWS;
                }else{
                    return Permit.R__;
                }
            }
        }

        return Permit.R__;
    }

    private Post firstPost(Post p){

        Post postFirst = null;
        while (p.getPostShare() != null){
            postFirst = p.getPostShare();
            p = p.getPostShare();
        }

        return postFirst;

    }

    public List<PostTO> listTO(List<Post> postList, Long currentId) {

        if(postList == null){return null;}

        List<PostTO> list = new ArrayList<PostTO>(postList.size());

        for(Post post : postList){
            list.add(createPostTO(post,currentId));

        }

        return list;
    }
}
