package com.tfg.api.projecte_tfg.builder;

import com.tfg.api.projecte_tfg.enums.Action;
import com.tfg.api.projecte_tfg.enums.Relation;
import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.*;
import com.tfg.api.projecte_tfg.rest.object.ListTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.rest.object.SearchItemTO;
import com.tfg.api.projecte_tfg.service.*;
import com.tfg.api.projecte_tfg.util.StringUtils;

import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by marc on 28/04/14.
 */
@Stateless
@LocalBean
public class SearchBuilder {
    @EJB
    UserBuilder userBuilder;
    @EJB
    GrupBuilder grupBuilder;
    @EJB
    PostBuilder postBuilder;


    public SearchItemTO createObjectListSearch(List<Grup> grupList, List<User> userList,List<Post> postList,
                                               List<String> hashtags, Long currentId) {

        SearchItemTO searchItemTO = new SearchItemTO(ModelJSON.OK,ModelJSON.MSG_EMPTY,currentId,null,null);



        List<Object> list = new ArrayList<Object>(
                (grupList != null ? grupList.size() : 0) +
                        (userList != null ? userList.size() : 0) +
                        (postList != null ? postList.size() : 0));

        if(grupList != null){
            list.addAll(grupBuilder.ListGrupTOLite(grupList,currentId).getList());
        }
        if(userList != null){
            list.addAll(userBuilder.ListTO(userList,currentId));
        }
        if(postList != null){
            //list.addAll(postBuilder.listTO(postList, currentId));
        } 

        searchItemTO.setList(list);
        searchItemTO.setHashtag(hashtags);

        return searchItemTO;
    }


    public SearchItemTO error(String s) {
        return new SearchItemTO(ModelJSON.ERROR,s,null,null,null);
    }
}
