package com.tfg.api.projecte_tfg.builder;

import com.tfg.api.projecte_tfg.enums.Action;
import com.tfg.api.projecte_tfg.enums.Relation;
import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.*;
import com.tfg.api.projecte_tfg.rest.object.*;
import com.tfg.api.projecte_tfg.service.*;

import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by marc on 01/04/14.
 */

@Stateless
@LocalBean
public class UserBuilder {

    @EJB
    AuthService authService;
    @EJB
    UserService userService;
    @EJB
    ImageUserService imageUserService;
    @EJB
    FriendService friendService;
    @EJB
    PostService postService;
    @EJB
    Grup_UserService grup_userService;
    @EJB
    NotificationsService notificationsService;
    @EJB
    FollowGrupService followGrupService;

    @EJB
    InfoUserBuilder iub;

    public UserBuilder(){}


    public ListTO<UserTO> ListSearch(List<User> list, Long id) {

        ListTO<UserTO> l = new ListTO<UserTO>(id);
        if(list != null) {
            for(User u : list){
                String mail = "";
                Integer notification = 0;
               l.put(createUserTO(u,id));
            }
        }

        return l;
    }

    public UserTO createUserTOLite(User u,Long currentId){
        if(u == null){ return null;}
        try{
            Long id = u.getId();
            String name = u.getNom();
            String secondname = u.getCognoms();
            Action action = Action.USER;
            Long notification = notificationsService.getCountNew(currentId);
            Relation relation = Relation.OWN;
            Long nfollow = null;
            Long nfollowers = null;
            Long npost = null;
            List<GrupMember> l = grup_userService.getGrupsByUserId(u.getId());
            List<MemberTO> lsimple = this.makeMember(l);
            Long nFavGrup = null;

            return new UserTO(currentId,id,name,secondname,"",notification,action,"",
                relation,null,null,nfollow,nfollowers,npost,lsimple,nFavGrup);
        }
        catch (Exception e){
            return Error("Error" + e.toString());
        }

    }

    public UserTO createUserTO(User u,Long currentId){

        try{

            if(u == null){return null;}

            UserTO userTO = createUserTOWhitOutPhoto(u,currentId);


            ImageUser iu = iub.getPhoto(u);
            byte[] imguser = iu == null ? null : iu.getImagen();
            userTO.setImg(imguser);

            return userTO;

        }catch (Exception e){
            return null;
        }

    }

    public UserTO createUserTOWhitOutPhoto(User u,Long currentId){
        if(u == null){ return null;}

        Auth au = authService.findbyUserId(u.getId());
        Friend f = friendService.match(currentId,u.getId());

        Long id = u.getId();
        String name = u.getNom();
        String secondname = u.getCognoms();



        Long notification = null;
        Action action = Action.USER;
        String description = u.getDescription();

        Relation relation = null;

        if(f == null){

            if(currentId.equals(u.getId())){
                relation = Relation.OWN;
            }else{
                relation = Relation.NO_FRIEND;
            }

        }else{

            if(f.getStatus().equals(Status.PENDING)){
                relation = Relation.NO_FRIEND;
            }else if(f.getStatus().equals(Status.OK)){
                relation = Relation.FRIEND;
            }else if(f.getStatus().equals(Status.NO)) {
                relation = Relation.NO_FRIEND;
            }else {
                relation = null;
            }
        }

        String email = "";

        if(Relation.OWN.equals(relation)){ //OWN
            email = au != null ? au.getEmail() : "";
        }

        Long commonFriends = currentId == u.getId() ? null : friendService.getCommonFriends(currentId, u.getId());

        byte[] imguser = null;

        Long nfollow = friendService.getFollows(u.getId());
        Long nfollowers = friendService.getFollowers(u.getId());
        Long npost = postService.getTotalPostFromUser(u.getId());
        Long nFavGrup = followGrupService.getCountGrupsFollow(u.getId());

        List<GrupMember> l = grup_userService.getGrupsByUserId(u.getId());
        List<MemberTO> lsimple = this.makeMember(l);

        return new UserTO(currentId,id,name,secondname,email,notification,action,description,
                relation,commonFriends,imguser,nfollow,nfollowers,npost,lsimple,nFavGrup);
    }



    public UserTO Error(String msg){
        return new UserTO(ModelJSON.ERROR, msg,
                null,null,null,null,null,null, Action.NOTHING,null,null,null,null,null,null,null,null,null);
    }

    public List<MemberTO> makeMember(List<GrupMember> l){

        List<MemberTO> lsimple = new ArrayList<MemberTO>(l.size());

        for (GrupMember g : l){

            lsimple.add(new MemberTO(g.getGrup().getId(),g.getGrup().getNom(),g.getTypemember(),g.getStatus(),g.getRol()));
        }
        return lsimple;
    }

    public List<UserTO> ListTO(List<User> l, Long currentId) {

        if(l == null){return null;}

        List<UserTO> lsimple = new ArrayList<UserTO>(l.size());

        for (User u : l){

            lsimple.add(createUserTO(u,currentId));
        }
        return lsimple;

    }

    public UserTO createUserTOSimple(User u, Long currentId) {
        if(u == null){ return null;}

        Long id = u.getId();
        String name = u.getNom();
        String secondname = u.getCognoms();

        Long notification = null;
        Action action = Action.USER;
        Relation relation = null;


        String email = "";


        Long commonFriends = null;

        byte[] imguser = null;

        Long nfollow = null;
        Long nfollowers = null;
        Long npost = null;
        Long nFavGrup = null;


        String description = "";
        List<MemberTO> lsimple = null;

        return new UserTO(currentId,id,name,secondname,email,notification,action,description,
                relation,commonFriends,imguser,nfollow,nfollowers,npost,lsimple,nFavGrup);
    }
}
