package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.util.LongAdapter;
import org.hibernate.validator.constraints.NotEmpty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.io.Serializable;

/**
 * Created by marc on 18/03/14.
 */
@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class Auth extends Model implements Serializable {

    /**
     * Default value included to remove warning. Remove or modify at will. *
     */
    private static final long serialVersionUID = 1L;

    @NotNull
    @Column(name = "EMAIL", length = 50,unique = true)
    private String email;

    @XmlTransient
    @NotNull
    @NotEmpty
    @Column(name = "PWD", length = 50)
    private String password;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdUSER", referencedColumnName="ID")
    private User user;

    public Auth(){};

    public Auth(String email, String password) {
        this.email = email;
        this.password = password;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }
}
