package com.tfg.api.projecte_tfg.model;

import org.hibernate.validator.constraints.NotEmpty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;

/**
 * Created by marc on 09/05/14.
 */
@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class Commentary extends Model implements Serializable {

    @NotNull
    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "Post", referencedColumnName="ID")
    private Post post;

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "User", referencedColumnName="ID")
    private User user;

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "Grup", referencedColumnName="ID")
    private Grup grup;

    /*
    *  Máximo del msg 140 carc.
    * */
    @NotNull
    @NotEmpty
    @Column(name = "Text", length = 150)
    private String text;

    public Commentary(){}

    public Commentary(Post post, User user, Grup grup, String text) {
        this.post = post;
        this.user = user;
        this.grup = grup;
        this.text = text;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Grup getGrup() {
        return grup;
    }

    public void setGrup(Grup grup) {
        this.grup = grup;
    }

    public Post getPost() {
        return post;
    }

    public void setPost(Post post) {
        this.post = post;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }
}
