package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.enums.Status;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;

/**
 * Created by marc on 01/04/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class Friend extends Model implements Serializable {

    @NotNull
    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdUSER1", referencedColumnName="ID")
    private User user1;

    @NotNull
    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdUSER2", referencedColumnName="ID")
    private User user2;

    @Column(name = "STATUS")
    @Enumerated(EnumType.STRING)
    private Status status;

    public Friend(User user1, User user2, Status status) {
        this.user1 = user1;
        this.user2 = user2;
        this.status = status;
    }

    public Friend() {
    }

    public User getUser1() {
        return user1;
    }

    public void setUser1(User user1) {
        this.user1 = user1;
    }

    public User getUser2() {
        return user2;
    }

    public void setUser2(User user2) {
        this.user2 = user2;
    }

    public Status getStatus() {
        return status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }
}
