package com.tfg.api.projecte_tfg.model;

import org.hibernate.Hibernate;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * Created by marc on 22/04/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class Grup extends Model implements Serializable{

    @Column(name = "NOM", length = 50, unique = true)
    private String nom;

    @JoinColumn(name = "ID_StyleMusic", referencedColumnName = "ID")
    @ManyToOne(optional = true, fetch = FetchType.EAGER)
    private StyleMusic styleMusic;

    @Column(name = "DESCRIPTION", length = 150)
    private String description;

    @Column(name = "FOUNDED")
    private Date founded;

    @Column(name = "ACTIVE")
    private Boolean active;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "grup",
            fetch = FetchType.LAZY)
    private List<GrupMember> users;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "ImageId", referencedColumnName="ID")
    private ImageUser image;

    public Grup() {
    }

    public Grup(String nom, StyleMusic styleMusic, String description, Date founded,Boolean active,
                ImageUser image) {
        this.nom = nom;
        this.styleMusic = styleMusic;
        this.description = description;
        this.founded = founded;
        this.active = active;
        this.image = image;
    }

    public ImageUser getImage() {
        return image;
    }

    public void setImage(ImageUser image) {
        this.image = image;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public StyleMusic getStyleMusic() {
        return styleMusic;
    }

    public void setStyleMusic(StyleMusic styleMusic) {
        this.styleMusic = styleMusic;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Date getFounded() {
        return founded;
    }

    public void setFounded(Date founded) {
        this.founded = founded;
    }

    public List<GrupMember> getUsersEAGER() {
        Hibernate.initialize(users);
        return users;
    }

    public List<GrupMember> getUsers() {
        return users;
    }

    public void setUsers(List<GrupMember> users) {
        this.users = users;
    }

    public Boolean getActive() {
        return active;
    }

    public void setActive(Boolean active) {
        this.active = active;
    }

    @Override
    public String toString() {
        return this.nom;
    }
}
