package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.enums.Member;
import com.tfg.api.projecte_tfg.enums.Status;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;

/**
 * Created by marc on 22/04/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class GrupMember extends Model implements Serializable {

    @NotNull
    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdUSER", referencedColumnName="ID")
    private User user;

    @NotNull
    @ManyToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdGRUP", referencedColumnName="ID")
    private Grup grup;

    @Column(name = "STATUS")
    @Enumerated(EnumType.STRING)
    private Status status;

    @Column(name = "TYPE_MEMBER")
    @Enumerated(EnumType.STRING)
    private Member typemember;

    @Column(name = "ROL")
    private String rol;



    public GrupMember(User user, Grup grup, Status status, Member typemember,String rol) {
        this.user = user;
        this.grup = grup;
        this.status = status;
        this.typemember = typemember;
        this.rol = rol;
    }


    public String getRol() {
        return rol;
    }

    public void setRol(String rol) {
        this.rol = rol;
    }

    public GrupMember() {
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Grup getGrup() {
        return grup;
    }

    public void setGrup(Grup grup) {
        this.grup = grup;
    }

    public Status getStatus() {
        return status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public Member getTypemember() {
        return typemember;
    }

    public void setTypemember(Member typemember) {
        this.typemember = typemember;
    }

}
