package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.util.LongAdapter;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.io.Serializable;

/**
 * Created by marc on 25/03/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class ImageUser extends Model implements Serializable{

    private static final long serialVersionUID = 1L;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdUSER", referencedColumnName="ID")
    private User user;

    @Lob
    @Column(name = "Imagen")
    private byte[] imagen;

    @Column(name = "Tamano")
    private Float tamano;

    @Column(name = "Name")
    private String name;

    @Column(name = "Type")
    private String type;

    public ImageUser(){}

    public ImageUser(User user, byte[] imagen, Float tamano, String name, String type) {
        this.user = user;
        this.imagen = imagen;
        this.tamano = tamano;
        this.name = name;
        this.type = type;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public byte[] getImagen() {
        return imagen;
    }

    public void setImagen(byte[] imagen) {
        this.imagen = imagen;
    }

    public Float getTamano() {
        return tamano;
    }

    public void setTamano(Float tamano) {
        this.tamano = tamano;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
}
