package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.enums.Person;
import com.tfg.api.projecte_tfg.enums.Privacity;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;
import java.util.Date;

/**
 * Created by marc on 25/03/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class InfoUser extends Model implements Serializable{

    @Column(name = "Person")
    @Enumerated(EnumType.STRING)
    private Person sex;

    @Column(name = "Birthday")
    private Date birthday;

    @Column(name = "Country")
    private String country;

    @Column(name = "City")
    private String city;

    @Column(name = "Phone")
    private String phone;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdUSER", referencedColumnName="ID")
    private User user;

    @Column(name = "SexPrivacity")
    @Enumerated(EnumType.STRING)
    private Privacity sexPrivacity;

    @Column(name = "BirthdayPrivacity")
    @Enumerated(EnumType.STRING)
    private Privacity birthdayPrivacity;

    @Column(name = "CountryPrivacity")
    @Enumerated(EnumType.STRING)
    private Privacity countryPrivacity;

    @Column(name = "CityPrivacity")
    @Enumerated(EnumType.STRING)
    private Privacity cityPrivacity;

    @Column(name = "PhonePrivacity")
    @Enumerated(EnumType.STRING)
    private Privacity phonePrivacity;

    @Column(name = "emailContact")
    private String emailContact;

    @Column(name = "emailContactPrivacity")
    @Enumerated(EnumType.STRING)
    private Privacity emailContactPrivacity;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "ImageId", referencedColumnName="ID")
    private ImageUser image;



    public InfoUser(){}

    public InfoUser(Person sex, Date birthday, String country, String city, String phone, User user,
                    Privacity sexPrivacity, Privacity birthdayPrivacity, Privacity countryPrivacity,
                    Privacity cityPrivacity, Privacity phonePrivacity,String emailContact,
                    Privacity emailContactPrivacity,ImageUser image) {
        this.sex = sex;
        this.birthday = birthday;
        this.country = country;
        this.city = city;
        this.phone = phone;
        this.user = user;
        this.sexPrivacity = sexPrivacity;
        this.birthdayPrivacity = birthdayPrivacity;
        this.countryPrivacity = countryPrivacity;
        this.cityPrivacity = cityPrivacity;
        this.phonePrivacity = phonePrivacity;
        this.emailContact = emailContact;
        this.emailContactPrivacity = emailContactPrivacity;
        this.image = image;

    }

    public ImageUser getImage() {
        return image;
    }

    public void setImage(ImageUser image) {
        this.image = image;
    }

    public Privacity getEmailContactPrivacity() {
        return emailContactPrivacity;
    }

    public void setEmailContactPrivacity(Privacity emailContactPrivacity) {
        this.emailContactPrivacity = emailContactPrivacity;
    }

    public String getEmailContact() {
        return emailContact;
    }

    public void setEmailContact(String emailContact) {
        this.emailContact = emailContact;
    }

    public Person getSex() {
        return sex;
    }

    public void setSex(Person sex) {
        this.sex = sex;
    }

    public Date getBirthday() {
        return birthday;
    }

    public void setBirthday(Date birthday) {
        this.birthday = birthday;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Privacity getSexPrivacity() {
        return sexPrivacity;
    }

    public void setSexPrivacity(Privacity sexPrivacity) {
        this.sexPrivacity = sexPrivacity;
    }

    public Privacity getBirthdayPrivacity() {
        return birthdayPrivacity;
    }

    public void setBirthdayPrivacity(Privacity birthdayPrivacity) {
        this.birthdayPrivacity = birthdayPrivacity;
    }

    public Privacity getCountryPrivacity() {
        return countryPrivacity;
    }

    public void setCountryPrivacity(Privacity countryPrivacity) {
        this.countryPrivacity = countryPrivacity;
    }

    public Privacity getCityPrivacity() {
        return cityPrivacity;
    }

    public void setCityPrivacity(Privacity cityPrivacity) {
        this.cityPrivacity = cityPrivacity;
    }

    public Privacity getPhonePrivacity() {
        return phonePrivacity;
    }

    public void setPhonePrivacity(Privacity phonePrivacity) {
        this.phonePrivacity = phonePrivacity;
    }
}
