package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.enums.TypeNotifications;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Created by marc on 28/04/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class Notifications extends Model {


    @Column(name = "TypeOf", length = 25,nullable = false)
    @Enumerated(EnumType.STRING)
    private TypeNotifications TypeOf;

    @Column(name = "isNew",nullable = false)
    private boolean isNew;

    @Column(name = "status", length = 20,nullable = false)
    @Enumerated(EnumType.STRING)
    private Status status;

    @Column(name = "description", length = 60,nullable = false)
    private String description;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "user_to",
            referencedColumnName="ID",
            nullable = false)
    private User user_to;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "grup_to", referencedColumnName="ID")
    private Grup grup_to;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "user_from", referencedColumnName="ID")
    private User user_from;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "grup_from", referencedColumnName="ID")
    private Grup grup_from;

    public Notifications(TypeNotifications typeOf, boolean isNew, Status status,
                         String description, User user_to, Grup grup_to, User user_from, Grup grup_from) {
        TypeOf = typeOf;
        this.isNew = isNew;
        this.status = status;
        this.description = description;
        this.user_to = user_to;
        this.grup_to = grup_to;
        this.user_from = user_from;
        this.grup_from = grup_from;
    }



    public Notifications() {
    }

    public Grup getGrup_from() {
        return grup_from;
    }

    public void setGrup_from(Grup grup_from) {
        this.grup_from = grup_from;
    }

    public User getUser_to() {
        return user_to;
    }

    public void setUser_to(User user_to) {
        this.user_to = user_to;
    }

    public Grup getGrup_to() {
        return grup_to;
    }

    public void setGrup_to(Grup grup_to) {
        this.grup_to = grup_to;
    }

    public User getUser_from() {
        return user_from;
    }

    public void setUser_from(User user_from) {
        this.user_from = user_from;
    }

    public TypeNotifications getTypeOf() {
        return TypeOf;
    }

    public void setTypeOf(TypeNotifications typeOf) {
        TypeOf = typeOf;
    }

    public boolean getIsNew() {
        return isNew;
    }

    public void setIsNew(boolean show) {
        this.isNew = show;
    }

    public Status getStatus() {
        return status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}
