package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.enums.TypePost;
import com.tfg.api.projecte_tfg.util.LongAdapter;
import org.hibernate.validator.constraints.NotEmpty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.io.Serializable;

/**
 * Created by marc on 26/03/14.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class Post extends Model implements Serializable{

    /*
    *
    *  Máximo del msg 140 carc.
    *
    * */
    @NotNull
    @NotEmpty
    @Column(name = "Text", length = 150)
    private String text;

    @Column(name = "dlt")
    protected Boolean delete;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "user_to", referencedColumnName="ID")
    private User user_to;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "grup_to", referencedColumnName="ID")
    private Grup grup_to;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "user_from", referencedColumnName="ID")
    private User user_from;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "grup_from", referencedColumnName="ID")
    private Grup grup_from;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdPostShare", referencedColumnName="ID")
    private Post postShare;

    @OneToOne( fetch = FetchType.EAGER)
    @JoinColumn(name = "IdSCTrack", referencedColumnName="ID")
    private SCTrack scTrack;

    public Post(){this.delete = false;}

    public Post(String text, Boolean delete, User user_to, Grup grup_to, User user_from, Grup grup_from, Post postShare,
                SCTrack scTrack) {
        this.text = text;
        this.delete = delete;
        this.user_to = user_to;
        this.grup_to = grup_to;
        this.user_from = user_from;
        this.grup_from = grup_from;
        this.postShare = postShare;
        this.scTrack = scTrack;
        this.delete = false;
    }

    public SCTrack getScTrack() {
        return scTrack;
    }

    public void setScTrack(SCTrack scTrack) {
        this.scTrack = scTrack;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public Boolean getDelete() {
        return delete;
    }

    public void setDelete(Boolean delete) {
        this.delete = delete;
    }

    public User getUser_to() {
        return user_to;
    }

    public void setUser_to(User user_to) {
        this.user_to = user_to;
    }

    public Grup getGrup_to() {
        return grup_to;
    }

    public void setGrup_to(Grup grup_to) {
        this.grup_to = grup_to;
    }

    public User getUser_from() {
        return user_from;
    }

    public void setUser_from(User user_from) {
        this.user_from = user_from;
    }

    public Grup getGrup_from() {
        return grup_from;
    }

    public void setGrup_from(Grup grup_from) {
        this.grup_from = grup_from;
    }

    public Post getPostShare() {
        return postShare;
    }

    public void setPostShare(Post postShare) {
        this.postShare = postShare;
    }
}
