package com.tfg.api.projecte_tfg.model;

import com.tfg.api.projecte_tfg.util.LongAdapter;
import org.hibernate.Hibernate;
import org.hibernate.validator.constraints.NotEmpty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.io.Serializable;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: marc
 * Date: 17/04/14
 * Time: 11:50
 * To change this template use File | Settings | File Templates.
 */

@Entity
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class User extends Model implements Serializable {
    /**
     * Default value included to remove warning. Remove or modify at will. *
     */
    private static final long serialVersionUID = 1L;

    @Column(name = "NOM", length = 50)
    private String nom;

    @Column(name = "COGNOMS", length = 60)
    private String cognoms;

    @Column(name = "DESCRIPTION", length = 150)
    private String description;

    public User(String nom, String cognoms) {
        this.nom = nom;
        this.cognoms = cognoms;
        this.description = "";
    }

    public User() {this.description = "";}

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public String getCognoms() {
        return cognoms;
    }

    public void setCognoms(String cognoms) {
        this.cognoms = cognoms;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public String toString() {
        return this.nom + " " + this.cognoms;
    }
}
