package com.tfg.api.projecte_tfg.rest;

import com.tfg.api.projecte_tfg.builder.CommentaryBuilder;
import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.enums.TypeNotifications;
import com.tfg.api.projecte_tfg.model.*;
import com.tfg.api.projecte_tfg.rest.object.CommentaryTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.rest.object.PostTO;
import com.tfg.api.projecte_tfg.service.CommentaryService;
import com.tfg.api.projecte_tfg.service.GrupService;
import com.tfg.api.projecte_tfg.service.PostService;
import com.tfg.api.projecte_tfg.service.UserService;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.ws.rs.FormParam;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;

/**
 * Created by marc on 09/05/14.
 */
@Path("/commentary")
@RequestScoped
public class CommentaryRESTService {
    @EJB
    private PostService postService;
    @EJB
    private UserService userService;
    @EJB
    private GrupService grupService;
    @EJB
    private CommentaryService commentaryService;
    @EJB
    private CommentaryBuilder commentaryBuilder;

    @POST
    @Produces("application/json")
    public CommentaryTO createCommentary(@Context HttpServletRequest req,
                             @FormParam("text") String text,
                             @FormParam("postId") Long postId,
                             @FormParam("userId") Long userId,
                             @FormParam("grupId") Long grupId
                             ) throws Exception {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (isSessionError(session)) return commentaryBuilder.createError("Error: Error de session");

        if (session.getAttribute("web_auth_id") == null) {
            return commentaryBuilder.createError(ModelJSON.MSG_EMPTY);
        } else {

            Long currentId = (Long) session.getAttribute("web_auth_id");

            Post post = postService.get(postId);
            User user = userService.getUser(userId);
            Grup grup = grupService.getGrup(grupId);

            if((post != null && user != null) || (post != null && grup != null)){

                Commentary commentary = new Commentary(post,user,grup,text);
                commentaryService.save(commentary);

                return commentaryBuilder.create(commentary,currentId);
            }

            return commentaryBuilder.createError("Error al fer el commentary");
        }

    }


    private boolean isSessionError(HttpSession session) {
        if (session == null) {
            return true;
        }
        return false;
    }
}
