package com.tfg.api.projecte_tfg.rest;

import com.tfg.api.projecte_tfg.model.Grup;
import com.tfg.api.projecte_tfg.model.GrupMember;
import com.tfg.api.projecte_tfg.model.User;
import com.tfg.api.projecte_tfg.rest.object.EventTO;
import com.tfg.api.projecte_tfg.rest.object.GrupTO;
import com.tfg.api.projecte_tfg.rest.object.ListTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.service.HashtagService;
import com.tfg.api.projecte_tfg.service.PostHashTagService;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import java.util.List;

/**
 * Created by marc on 14/05/14.
 */
@Path("/hashtag")
@RequestScoped
public class HashTagRESTService {

    @EJB
    private HashtagService hashtagService;
    @EJB
    private PostHashTagService postHashTagService;


    @GET
    @Path("/tendency")
    @Produces("application/json")
    public ListTO<String> getTendency(@Context HttpServletRequest req) throws Exception {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (session == null) {
            return new ListTO<String>(ModelJSON.ERROR,"Error: Error de session",null,null);

        }

        if (session.getAttribute("web_auth_id") == null) {
            return new ListTO<String>(ModelJSON.ERROR,"No auth",null,null);
        }

        Long id = (Long) session.getAttribute("web_auth_id");
        List<String> list = postHashTagService.getTodayTendency();

        return new ListTO<String>(ModelJSON.OK,ModelJSON.MSG_EMPTY,id,list);

    }
}
