package com.tfg.api.projecte_tfg.rest;

import com.tfg.api.projecte_tfg.model.ImageUser;
import com.tfg.api.projecte_tfg.model.User;
import com.tfg.api.projecte_tfg.rest.object.FileMeta;
import com.tfg.api.projecte_tfg.rest.object.ImageTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.rest.object.UserTO;
import com.tfg.api.projecte_tfg.service.ImageUserService;
import com.tfg.api.projecte_tfg.service.UserService;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;


/**
 * Created by marc on 25/03/14.
 */

@Path("/imageuser")
@RequestScoped
public class ImageUserRESTService {

    @EJB
    ImageUserService imageUserService;

    @EJB
    UserService us;

    @GET
    @Path("/my")
    @Produces("application/json")
    public ImageTO getHorari(@Context HttpServletRequest req) {

        try {


        }
        catch (Exception ex) {
            return null;
        }


        return null;

    }


    /***************************************************
     * URL: /rest/controller/upload upload(): receives files
     *
     * @param request
     *            : MultipartHttpServletRequest auto passed
     * @param response
     *            : HttpServletResponse auto passed
     * @return LinkedList<FileMeta> as json format
     ****************************************************/

    @Path("/upload")
    @POST
    @Produces("application/json")
    public @ResponseBody
    LinkedList<FileMeta> upload(@Context HttpServletRequest req,MultipartHttpServletRequest request,
                                HttpServletResponse response,
                                @FormParam("value") Long value) throws Exception {

        HttpSession session = req.getSession();

        if (session == null) {
            return null;
        }

        if (session.getAttribute("web_auth_id") == null) {
            return null;
        }


        Long id = (Long) session.getAttribute("web_auth_id");
        User u = us.getUser(id);


        LinkedList<FileMeta> files = new LinkedList<FileMeta>();
        FileMeta fileMeta = null;

        if (value == null) {
            return null;
        }

        // 1. builder an iterator
        Iterator<String> itr = request.getFileNames();
        MultipartFile mpf = null;

        // 2. get each file
        while (itr.hasNext()) {

            // 2.1 get next MultipartFile
            mpf = request.getFile(itr.next());
            System.out.println(mpf.getOriginalFilename() + " uploaded! "
                    + files.size());

            // 2.2 if files > 10 remove the first from the list
            if (files.size() >= 10)
                files.pop();

            // 2.3 create new fileMeta
            fileMeta = new FileMeta();
            fileMeta.setFileName(mpf.getOriginalFilename());
            fileMeta.setFileSize(mpf.getSize() / 1024 + " Kb");
            fileMeta.setFileType(mpf.getContentType());

            try {
                fileMeta.setBytes(mpf.getBytes());
            } catch (IOException e) {
                e.printStackTrace();
            }


            ImageUser imageUser = new ImageUser();
            imageUser.setImagen(fileMeta.getBytes());
            imageUser.setUser(u);
            imageUser.setName(fileMeta.getFileName());
            imageUser.setTamano((float) fileMeta.getBytes().length);
            imageUser.setType(fileMeta.getFileType());


            // 2.4 add to files
            files.add(fileMeta);
        }

        return files;
    }
}
