package com.tfg.api.projecte_tfg.rest;

import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;
import com.tfg.api.projecte_tfg.builder.InfoUserBuilder;
import com.tfg.api.projecte_tfg.model.Auth;
import com.tfg.api.projecte_tfg.model.ImageUser;
import com.tfg.api.projecte_tfg.model.InfoUser;
import com.tfg.api.projecte_tfg.model.User;
import com.tfg.api.projecte_tfg.rest.object.InfoUserTO;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.service.AuthService;
import com.tfg.api.projecte_tfg.service.ImageUserService;
import com.tfg.api.projecte_tfg.service.InfoUserService;
import com.tfg.api.projecte_tfg.service.UserService;
import com.tfg.api.projecte_tfg.util.FileToArrayOfBytes;
import com.tfg.api.projecte_tfg.util.StringUtils;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import java.io.File;


/**
 * Created by marc on 25/03/14.
 */


@Path("/infouser")
@RequestScoped
public class InfoUserRESTService {

    @EJB
    private InfoUserService ius;
    @EJB
    private UserService us;
    @EJB
    AuthService authService;
    @EJB
    InfoUserBuilder iub;
    @EJB
    ImageUserService imageUserService;

    @GET
    @Path("user/{id}")
    @Produces("application/json")
    public InfoUserTO getInfoUser(@Context HttpServletRequest req,
                                  @PathParam("id") Long id) {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (session == null) {
            return iub.error("Error: Error de session");

        }

        if (session.getAttribute("web_auth_id") == null) {
            return iub.error(ModelJSON.MSG_EMPTY);
        }


        Long currentid = (Long) session.getAttribute("web_auth_id");
        try {

            InfoUser iu = ius.getByIdUser(id);

            if (iu == null){
                Auth au = authService.findbyUserId(us.getUser(id).getId());
                iu = ius.save(iub.defauldInfoUser(us.getUser(id),au));
            }

            Auth au = authService.findbyUserId(id);
            return iub.createOK(iu,au,currentid);

        }
        catch (Exception ex) {
            return null;
        }

    }

    @GET
    @Path("my")
    @Produces("application/json")
    public InfoUserTO getOwnInfoUser(@Context HttpServletRequest req) {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (session == null) {
            return iub.error("Error: Error de session");

        }

        if (session.getAttribute("web_auth_id") == null) {
            return iub.error(ModelJSON.MSG_EMPTY);
        }


        Long id = (Long) session.getAttribute("web_auth_id");
        try {

            InfoUser iu = ius.getByIdUser(id);

            if (iu == null){
                Auth au = authService.findbyUserId(us.getUser(id).getId());
                iu = ius.save(iub.defauldInfoUser(us.getUser(id),au));
            }

            Auth au = authService.findbyUserId(id);
            return iub.createOK(iu,au,id);

        }
        catch (Exception ex) {
            return null;
        }

    }

    @PUT
    @Path("my/persoanl")
    @Produces("application/json")
    public InfoUserTO editOwnInfoUser(
            @Context HttpServletRequest req,
            @FormParam("name") String name,
            @FormParam("secondname") String secondname,
            @FormParam("birthday") String birthday,
            @FormParam("birthdayPrivacity") String birthdayPrivacity,
            @FormParam("Person") String sex,
            @FormParam("SexPrivacity") String sexPrivacity,
            @FormParam("city") String city,
            @FormParam("cityPrivacity") String cityPrivacity,
            @FormParam("country") String country,
            @FormParam("countryPrivacity") String countryPrivacity,
            @FormParam("photo") String photo,
            @FormParam("description") String description) {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (session == null) {
            return iub.error("Error: Error de session");

        }

        if (session.getAttribute("web_auth_id") == null) {
            return iub.error(ModelJSON.MSG_EMPTY);
        }


        Long id = (Long) session.getAttribute("web_auth_id");
        try {

            InfoUser iu = ius.getByIdUser(id);
            User u = iu.getUser();

            if (iu == null){
                Auth au = authService.findbyUserId(us.getUser(id).getId());
                iu = ius.save(iub.defauldInfoUser(us.getUser(id),au));
            }

            ImageUser imageUser = null;

            if(photo != null){

                System.out.print("size" + photo.length());
                System.out.print(photo);

                String[] img = photo.split("base64,");
                String image = img[1];

                byte[] decoded = org.apache.commons.codec.binary.Base64.decodeBase64(image.getBytes());


                imageUser = new ImageUser(u, decoded,0f,"","Principal");
                imageUserService.save(imageUser);

            }

            iu = iub.edit(iu, u, name, secondname, birthday, birthdayPrivacity,
                    sex, sexPrivacity, city, cityPrivacity, country,
                    countryPrivacity,description,imageUser);



            return iub.createOK(iu,authService.findbyUserId(id),id);

        }
        catch (Exception ex) {
            return null;
        }

    }


}
