package com.tfg.api.projecte_tfg.rest;



import com.tfg.api.projecte_tfg.builder.UserBuilder;
import com.tfg.api.projecte_tfg.enums.Action;
import com.tfg.api.projecte_tfg.model.Auth;
import com.tfg.api.projecte_tfg.model.User;
import com.tfg.api.projecte_tfg.rest.object.ModelJSON;
import com.tfg.api.projecte_tfg.rest.object.UserTO;
import com.tfg.api.projecte_tfg.service.UserService;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.xml.bind.JAXBContext;
import java.io.StringWriter;
import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: marc
 * Date: 17/04/14
 * Time: 12:06
 * To change this template use File | Settings | File Templates.
 */

@Path("/user")
@RequestScoped
public class UserRESTService {

    @EJB
    UserService us;
    @EJB
    UserBuilder ub;

    @GET
    @Path("/my")
    @Produces("application/json")
    public UserTO getOwn(@Context HttpServletRequest req) throws Exception {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (session == null) {
            return ub.Error("Session Error.");
        }

        if (session.getAttribute("web_auth_id") == null) {
            return ub.Error("No auth");
        }
        else {

            Long id = (Long) session.getAttribute("web_auth_id");
            User u = us.getUser(id);

            if (u != null){
                return ub.createUserTO(u,id);
            }else{

                session.setAttribute("web_auth_id", null);
                return ub.Error("No auth");
            }
        }

    }

    @GET
    @Path("/infoLite")
    @Produces("application/json")
    public UserTO getOwnInfoLite(@Context HttpServletRequest req) throws Exception {

        // Access to the HTTP session
        HttpSession session = req.getSession();

        if (session == null) {
            return ub.Error("Session Error.");
        }

        if (session.getAttribute("web_auth_id") == null) {
            return ub.Error("No auth");
        }
        else {

            Long id = (Long) session.getAttribute("web_auth_id");
            User u = us.getUser(id);

            if (u != null){
                return ub.createUserTOLite(u,id);
            }else{

                session.setAttribute("web_auth_id", null);
                return ub.Error("No auth");
            }
        }

    }



}
