package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.Auth;
import com.tfg.api.projecte_tfg.model.User;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * Created by marc on 18/03/14.
 */
@Stateless
@LocalBean
public class AuthService {

    @PersistenceContext
    private EntityManager em;

    public Auth matchPassword(String email, String password) {

        Query q = em.createQuery("select au from Auth au where au.email=:email");
        q.setParameter("email", email);

        try {
            Auth au = (Auth) q.getSingleResult();
            return au.getPassword().equals(password) ? au : null;
        }
        catch (Exception e) {
            return null;
        }
    }

    public Auth save(Auth auth) {
        try{
            em.persist(auth);
            em.flush();
            return auth;
        }catch (Exception e){
            return null;
        }
    }

    public Auth merge(Auth auth) {
        try{
            auth = em.merge(auth);
            em.flush();
            return auth;
        }catch (Exception e){
            return null;
        }
    }

    public Auth findbyEmail(String email) {

        Query q = em.createQuery("select au from Auth au where au.email=:email");
        q.setParameter("email", email);

        try {
            return (Auth) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public Auth findbyUserId(Long id) {

        Query q = em.createQuery("select au from Auth au where au.user.id=:id");
        q.setParameter("id", id);

        try {
            return (Auth) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }
}
