package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.Commentary;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.Date;
import java.util.List;

/**
 * Created by marc on 09/05/14.
 */
@Stateless
@LocalBean
public class CommentaryService {

    @PersistenceContext
    private EntityManager em;

    public void save(Commentary commentary) {
        em.persist(commentary);
    }

    public List<Commentary> getAllByPostId(Long postId) {
        try{
            Query q = em.createQuery("select c from Commentary c " +
                    "where c.post.id =:postId");
            q.setParameter("postId", postId);

            return (List<Commentary>) q.getResultList();

        }catch (Exception e){
            return null;
        }
    }

    public Commentary find(Long commentaryId) {
        return em.find(Commentary.class,commentaryId);
    }
}
