package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.EventGrup;
import com.tfg.api.projecte_tfg.model.FollowGrup;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.Date;
import java.util.List;

/**
 * Created by marc on 08/05/14.
 */

@Stateless
@LocalBean
public class EventGrupService {

    @PersistenceContext
    private EntityManager em;

    public void save(EventGrup eventGrup) {
        em.persist(eventGrup);
    }

    public List<EventGrup> getActiveEventsTop10ByGrupId(Long grupId) {
        try{
            Query q = em.createQuery("select e from EventGrup e " +
                    "where e.date > :date and e.grup.id =:grupId order by e.createdAt asc ");

            q.setParameter("date", new Date());
            q.setParameter("grupId", grupId);

            return (List<EventGrup>) q.getResultList();

        }catch (Exception e){
            return null;
        }
    }
}
