package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.FollowGrup;
import com.tfg.api.projecte_tfg.model.Grup;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

/**
 * Created by marc on 02/05/14.
 */
@Stateless
@LocalBean
public class FollowGrupService {

    @PersistenceContext
    private EntityManager em;


    public FollowGrup match(Long userId, Long grupId) {

        try {

            Query q = em.createQuery("select f from FollowGrup f where f.user.id=:userId and f.grup.id=:grupId");

            q.setParameter("userId", userId);
            q.setParameter("grupId", grupId);

            return (FollowGrup) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public void save(FollowGrup followGrup) {
        em.persist(followGrup);
    }

    public void update(FollowGrup followGrup) {
        em.merge(followGrup);
    }

    public Long getCountGrupsFollow(Long userId) {
        try {

            Query q = em.createQuery("select count(f) from FollowGrup f where f.user.id=:userId and f.follow=true");

            q.setParameter("userId", userId);

            return (Long) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public List<Grup> getListGrupsFollow(Long userId) {
        try {

            Query q = em.createQuery("select f.grup from FollowGrup f where f.user.id=:userId and f.follow=true");

            q.setParameter("userId", userId);

            return (List<Grup>) q.getResultList();
        }
        catch (Exception e) {
            return null;
        }
    }

    public Long getFriendsFollow(Long grupId, Long userId) {
        try {

            Query q = em.createQuery("select count(f) from FollowGrup f " +
                    "where f.grup.id=:grupId and f.follow=true and " +
                    "f.user.id in ( select fr.user2.id from Friend fr " +
                    "where fr.user1.id=:userId and fr.status=:status)");

            q.setParameter("grupId", grupId);
            q.setParameter("userId", userId);
            q.setParameter("status", Status.OK);

            return (Long) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }
}
