package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.Grup;
import com.tfg.api.projecte_tfg.model.User;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

/**
 * Created by marc on 22/04/14.
 */

@Stateless
@LocalBean
public class GrupService {

    @PersistenceContext
    private EntityManager em;

    public Grup find(String name) {
        try {

            Query q = em.createQuery("select g from Grup g where g.nom=:name and g.active = true");

            q.setParameter("name", name);

            return (Grup) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }


    public Grup saveAndUpdate(Grup grup) {

        try {
            em.persist(grup);
            return grup;
        }catch (Exception e){
        }

        try {
            em.merge(grup);
            return grup;
        }catch (Exception e){
            return null;
        }
    }

    public void update(Grup g){
        em.merge(g);
        em.flush();
    }

    public Grup getGrup(Long id) {
        try {
            return em.find(Grup.class, id);
        }   catch (Exception e){return null;}
    }

    public List<Grup> getGrupByTextLike(String textSearch) {

        try {
            Query q = em.createQuery("select g from Grup g where g.nom like :text");
            q.setParameter("text", "%"+textSearch+"%");

            return (List<Grup>) q.getResultList();
        }
        catch (Exception e) {
            return null;
        }
    }
}
