package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.GrupMember;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

/**
 * Created by marc on 22/04/14.
 */
@Stateless
@LocalBean
public class Grup_UserService {

    @PersistenceContext
    private EntityManager em;

    public GrupMember save(GrupMember grup_member) {

        try {
            em.persist(grup_member);
            em.flush();
            return grup_member;
        }catch (Exception e){
            return null;
        }
    }

    public GrupMember update(GrupMember grup_member) {
        try {
            em.merge(grup_member);
            em.flush();
            return grup_member;
        }catch (Exception e){
            return null;
        }
    }

    public List<GrupMember> getGrupsByUserId(Long id) {
        try {

            Query q = em.createQuery("select g from GrupMember g where g.user.id=:id and g.status=:status");

            q.setParameter("id", id);
            q.setParameter("status", Status.OK);

            return q.getResultList();
        }
        catch (Exception e) {
            return null;
        }

    }

    public List<GrupMember> getUsersByGrupId(Long id) {
        try {
            Query q = em.createQuery("select g from GrupMember g where g.grup.id=:id and g.status<>:status");

            q.setParameter("id", id);
            q.setParameter("status", Status.NO);

            return q.getResultList();
        }
        catch (Exception e) {
            return null;
        }
    }

    public GrupMember match(Long grupId, Long userId) {
        try {
            Query q = em.createQuery("select g from GrupMember g where g.grup.id=:grupId and g.user.id=:userId");

            q.setParameter("grupId", grupId);
            q.setParameter("userId", userId);

            return (GrupMember)q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public GrupMember get(Long memberId) {
        return em.find(GrupMember.class, memberId);
    }
}
