package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.EventGrup;
import com.tfg.api.projecte_tfg.model.Hashtag;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * Created by marc on 09/05/14.
 */

@Stateless
@LocalBean
public class HashtagService {

    @PersistenceContext
    private EntityManager em;

    public Hashtag getByHashTag(String hashtag) {

        try{
            Query q = em.createQuery("select h from Hashtag h " +
                    "where h.hashtag =:hashtag");

            q.setParameter("hashtag", hashtag);
            return (Hashtag) q.getSingleResult();

        }catch (Exception e){
            return null;
        }
    }

    public void save(Hashtag hashtag) {
        em.persist(hashtag);
    }


    public List<String> getListHashtagsLike(String hashtag) {
        try{
            Query q = em.createQuery("select h.hashtag from Hashtag h " +
                    "where h.hashtag like :hashtag");

            q.setParameter("hashtag", "%"+hashtag+"%");

            return (List<String>) q.getResultList();

        }catch (Exception e){
            return null;
        }
    }
}
