package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.LikePost;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * Created by marc on 13/05/14.
 */
@Stateless
@LocalBean
public class LikePostService {

    @PersistenceContext
    private EntityManager em;

    public void save(LikePost likePost) {
        em.persist(likePost);
    }

    public LikePost matchPost(Long postId, Long userId) {

        Query q = em.createQuery("select l from LikePost l " +
                "where l.post.id=:postId and l.user.id=:userId");

        try {

            q.setParameter("postId", postId);
            q.setParameter("userId", userId);

            return (LikePost) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public LikePost matchCommentary(Long commentaryId, Long userId) {

        Query q = em.createQuery("select l from LikePost l " +
                "where l.commentary.id=:commentaryId and l.user.id=:userId");

        try {

            q.setParameter("commentaryId", commentaryId);
            q.setParameter("userId", userId);

            return (LikePost) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public void update(LikePost likePost) {
        em.merge(likePost);
        em.flush();
    }

    public Long countByPostId(Long postId) {
        Query q = em.createQuery("select count(l) from LikePost l " +
                "where l.post.id=:postId and l.like=:like");

        try {

            q.setParameter("postId", postId);
            q.setParameter("like", true);

            return (Long) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }

    public Long countByCommentaryId(Long commentaryId) {
        Query q = em.createQuery("select count(l) from LikePost l " +
                "where l.commentary.id=:commentaryId and l.like=:like");

        try {

            q.setParameter("commentaryId", commentaryId);
            q.setParameter("like", true);

            return (Long) q.getSingleResult();
        }
        catch (Exception e) {
            return null;
        }
    }
}
