package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.Notifications;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

/**
 * Created by marc on 28/04/14.
 */

@Stateless
@LocalBean
public class NotificationsService {

    @PersistenceContext
    private EntityManager em;

    public List<Notifications> getNotificationsList(Long id,Integer max,Long page) {

        page = page == null ? 0 : page;

        Query q = em.createQuery("select n from Notifications n where n.user_to.id =:id " +
                " and n.status <> :Nostatus  order by n.createdAt desc");

        q.setParameter("id", id);
        q.setParameter("Nostatus", Status.NO);
        q.setMaxResults(max);
        q.setFirstResult((int) (max * page));

        return (List<Notifications>) q.getResultList();

    }

    public Notifications save(Notifications notifications) {

        em.persist(notifications);
        return notifications;
    }

    public Notifications getNotifications(Long idNotification) {

        return em.find(Notifications.class,idNotification);

    }

    public void update(Notifications notifications) {
        em.merge(notifications);
        em.flush();
    }


    public Long getCountNew(Long id) {

        Query q = em.createQuery("select count(n) from Notifications n where n.user_to.id =:id and n.isNew=:true " +
                "order by n.createdAt desc ");

        q.setParameter("id", id);
        q.setParameter("true", true);

        return (Long) q.getSingleResult();
    }

    public Long getCount(Long id) {
        Query q = em.createQuery("select count(n) from Notifications n where n.user_to.id =:id " +
                "order by n.createdAt desc ");

        q.setParameter("id", id);

        return (Long) q.getSingleResult();
    }

    public void delete(Notifications notifications) {
        em.remove(notifications);
    }

    public Notifications get(Long idNotification) {
        return em.find(Notifications.class, idNotification);
    }
}
