package com.tfg.api.projecte_tfg.service;

import com.tfg.api.projecte_tfg.model.SCTrack;
import com.tfg.api.projecte_tfg.util.DateUtils;
import com.tfg.api.projecte_tfg.util.Pair;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by marc on 12/05/14.
 */
@Stateless
@LocalBean
public class SCTrackService {

    @PersistenceContext
    private EntityManager em;

    public List<SCTrack> getListByGrup(Long grupId, Integer max, Long page) {
        try{

            page = page == null ? 0 : page;

            Query q = em.createQuery("select s from SCTrack s where s.grup.id=:id order by s.createdAt desc");

            q.setParameter("id", grupId);

            q.setMaxResults(max);
            q.setFirstResult((int) (max * page));

            return (List<SCTrack>) q.getResultList();

        }catch (Exception e){
            return null;
        }
    }

    public void save(SCTrack song) {
        em.persist(song);
        em.flush();
    }

    public List<SCTrack> top4(){

        //Select count(lp.ID) as likes, p.IdSCTrack from LikePost lp, Post p where p.ID = lp.postId and
        //lp.LikePost=true and lp.postId is not null and p.IdSCTrack is not null group by lp.postId order by likes;
        try{
            Query q = em.createQuery("Select p.scTrack from LikePost lp, Post p where p.id = lp.post.id and " +
                    "lp.like=true and lp.post.id is not null and p.scTrack.id is not null and lp.createdAt > :today " +
                    " group by lp.post.id order by count(lp.id) desc ");

            q.setParameter("today", DateUtils.get24hAgo());
            q.setMaxResults(4);

            return  (List<SCTrack>) q.getResultList();

        }catch (Exception e){
            return null;
        }

    }

    public List<SCTrack> top4Alltime() {
        try{
            Query q = em.createQuery("Select sc from SCTrack sc order by sc.updatedAt desc ");

            q.setMaxResults(5);

            return  (List<SCTrack>) q.getResultList();

        }catch (Exception e){
            return null;
        }
    }
}
