package com.tfg.api.projecte_tfg.service;


import com.tfg.api.projecte_tfg.enums.Status;
import com.tfg.api.projecte_tfg.model.Friend;
import com.tfg.api.projecte_tfg.model.Post;
import com.tfg.api.projecte_tfg.model.User;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import java.util.ArrayList;
import java.util.List;


/**
 * Created with IntelliJ IDEA.
 * User: marc
 * Date: 17/04/14
 * Time: 12:10
 * To change this template use File | Settings | File Templates.
 */



@Stateless
@LocalBean
public class UserService {

    @PersistenceContext
    private EntityManager em;


    public  User getUser(Long id) throws Exception {
        try{
            return em.find(User.class, id);
        }catch (Exception e){return null;}
    }

    public User save(User user) {
        try {
            em.persist(user);
            em.flush();
            return user;

        }   catch (Exception e){
            return null;
        }
    }

    public List<User> getUserByTextLike(String textSearch) {

        try {
            Query q = em.createQuery("select u from User u where concat(u.nom,' ',u.cognoms) like :text");
            q.setParameter("text", "%"+textSearch+"%");

            return (List<User>) q.getResultList();
        }
        catch (Exception e) {
            return null;
        }
    }

    public List<Friend> getFriendsrByTextLike(Long id, String textSearch) {

        try {
            Query q = em.createQuery("select f from Friend f where f.user1.id = :id and f.status =:status " +
                    "and  concat(f.user2.nom,' ',f.user2.cognoms) like :text");

            q.setParameter("id", id);
            q.setParameter("status", Status.OK);
            q.setParameter("text", "%"+textSearch+"%");

            return (List<Friend>) q.getResultList();

        }
        catch (Exception e) {
            return null;
        }
    }

    public void update(User u) {
        em.merge(u);
        em.flush();
    }

    public List<User> getFriendsrByTextLikeTop5(Long id, String textSearch) {

        try {
            Query q = em.createQuery("select f.user2 from Friend f where " +
                    " f.user1.id = :id and f.status =:status " +
                    "and  concat(f.user2.nom,' ',f.user2.cognoms) like :text");

            q.setParameter("id", id);
            q.setParameter("status", Status.OK);
            q.setParameter("text", "%"+textSearch+"%");
            q.setMaxResults(5);

            return (List<User>) q.getResultList() ;

        }
        catch (Exception e) {
            return null;
        }
    }

    public User getFriendsrByTextLikeTop1(Long id, String textSearch) {

        try {
            Query q = em.createQuery("select f.user2 from Friend f where " +
                    " f.user1.id = :id and f.status =:status " +
                    "and  concat(f.user2.nom,' ',f.user2.cognoms) like :text");

            q.setParameter("id", id);
            q.setParameter("status", Status.OK);
            q.setParameter("text", "%"+textSearch+"%");
            q.setMaxResults(1);

            return (User) q.getSingleResult() ;

        }
        catch (Exception e) {
            return null;
        }
    }


}
