package com.tfg.api.projecte_tfg.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * @Project terramar-utils
 * @author Marc Amorin
 * @date 22/08/2013 11:34:50
 **/

public class DateUtils {

    public static String SimpleDate(Date date) {

        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
                "dd/MM/yyyy  HH:mm");

        return sdf.format(date);

    }

    public static String Hour(Date date) {

        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
                "HH:mm");

        return sdf.format(date);

    }

    public static String CompleteDate(Date date) {

        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
                "dd/MM/yyyy - HH:mm:ss");

        return sdf.format(date);

    }

    public static String Date(Date date) {

        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
                "dd/MM/yyyy");
        return sdf.format(date);

    }

    public static String DateDecorator(Date date){
        Calendar c = new GregorianCalendar();

        for(int i = 0;i < 59;i++){
            c.setTimeInMillis(c.getTimeInMillis() - (1000*60));
            Date less = c.getTime();
            if(date.after(less)){
                if( i == 0){
                    return "Fa menys de 1 minut";
                }else if(i == 1){
                    return "Fa 1 minut";
                }
                return "Fa "+i+" minuts";
            }
        }

        c = new GregorianCalendar();

        for(int i = 0;i < 6;i++){
            c.setTimeInMillis(c.getTimeInMillis() - (1000*60*60));
            Date less = c.getTime();
            if(date.after(less)){
                i = i == 0 ? 1 : i;
                if(i != 1){
                return "Fa "+i+" hores";
                }else return "Fa 1 hora";
            }
        }

        c = new GregorianCalendar();

        c.set(Calendar.HOUR_OF_DAY, 0); //anything 0 - 23
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        Date today = c.getTime();

        c.add(Calendar.DAY_OF_YEAR, -1);
        Date yesterday = c.getTime();

        if(date.after(today)){
            return "Avui " + Hour(date);

        }   else if(date.after(yesterday)){
            return "Ahir " + Hour(date);

        }   else{
            return SimpleDate(date);
        }
    }


    public static Date create(String date) throws ParseException {
        DateFormat formatter = new SimpleDateFormat("dd/MM/yy");
        return formatter.parse(date);
    }

    public static Date createWithHour(String date) throws ParseException {
        DateFormat formatter = new SimpleDateFormat("dd/MM/yyyy HH:mm");
        return formatter.parse(date);
    }

    public static String DateDecoratorInverse(Date date) {

        Calendar c = new GregorianCalendar();

        for(int i = 0;i < 59;i++){
            c.setTimeInMillis(c.getTimeInMillis() + (1000*60));
            Date d = c.getTime();
            if(date.before(d)){

                if( i == 0){
                    return "En menys de 1 minut";
                }else if(i == 1){
                    return "En 1 minut";
                }
                return "En "+i+" minuts";
            }
        }

        c = new GregorianCalendar();

        for(int i = 0;i < 6;i++){
            c.setTimeInMillis(c.getTimeInMillis() + (1000*60*60));
            Date d = c.getTime();
            if(date.before(d)){
                i = i == 0 ? 1 : i;
                if(i != 1){
                    return "En "+ i +" hores";
                }else return "En 1 hora";
            }
        }

        c = new GregorianCalendar();

        c.set(Calendar.HOUR_OF_DAY, 0); //anything 0 - 23
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        c.add(Calendar.DAY_OF_YEAR, +1);
        Date today = c.getTime();

        c.add(Calendar.DAY_OF_YEAR, +1);
        Date tomorrow = c.getTime();



        if(date.before(today)){
            return "Avui " + Hour(date);

        }   else if(date.before(tomorrow)){
            return "Demà " + Hour(date);

        }   else{
            return SimpleDate(date);
        }
    }


    public static Boolean isTodat(Date date) {

        Calendar c = new GregorianCalendar();

        c.set(Calendar.HOUR_OF_DAY, 0); //anything 0 - 23
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        Date today = c.getTime();

        if(date.after(today)){
            return true;

        }else{
            return false;

        }
    }

    public static Date get24hAgo() {

        Calendar c = new GregorianCalendar();

        c.setTimeInMillis(c.getTimeInMillis() - (1000*60*60*24));

        return c.getTime();
    }

    public static Date today() {

        Calendar c = new GregorianCalendar();

        c.set(Calendar.HOUR_OF_DAY, 0); //anything 0 - 23
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        return c.getTime();

    }
}
