package com.tfg.api.projecte_tfg.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class StringUtils {

	public static boolean isEmptyChar(String val) {
		return val == null || "".equals(val.trim());
	}

	public static boolean notEmptyChar(String val) {
		return !isEmptyChar(val);
	}

	public static String trimBlanc(String message) {
		if (message != null) {
			return message.trim();
		}
		return "";
	}

	public static String trim(String message) {
		if (message != null) {
			return message.trim();
		}
		return null;
	}

	/**
	 * 
	 * @param arg1
	 * @param arg2
	 * @return returns equal if arg1==arg2
	 */
	public static boolean compareEqualNull(String arg1, String arg2) {
		String a = arg1 == null ? "" : arg1.trim();
		String b = arg2 == null ? "" : arg2.trim();
		return (a.equals(b));
	}

	public static String fillZero(Integer numZeros, String arg) {

        try{
            String a = arg;
            if (isEmptyChar(a)) {
                a = "0";
            }

            if (numZeros <= arg.length()) {
                return arg;
            }

            String zeros = "%0" + numZeros + "d";
            return String.format(zeros, Long.parseLong(a));
        }catch (Exception e){
            return null;
        }
	}

	public static String fillZero(Integer numZeros, Long arg) {

        try{
            String zeros = "%0" + numZeros + "d";
            return String.format(zeros, arg);
        }catch (Exception e ){
            return  null;
        }
	}

	public static String substring(String arg, int ini, int fin) {
		String a = arg;
		try {
			return a.substring(ini, fin);
		} catch (Exception e) {
			return a;
		}

	}


    public static String ConvertirPrimeraLetraEnMayuscula(String texto){

        try{

            texto = texto.trim();

            String[] l = texto.split(" ");
            String result = "";
            for(String s : l){
                if(!s.isEmpty()){
                    result += s.substring(0,1).toUpperCase() + s.substring(1,s.length())+" ";
                }
            }

            return result;
        }catch (Exception e){
            return null;
        }
    }

    public static List<Long> makeLongArray(String members) {

        try{

            String[] lo = members.split(",");
            List<Long> l = new ArrayList<Long>(lo.length);

            for (String s : lo) {
                Long x = Long.parseLong(s);
                l.add(x);
            }

            return l;

        }  catch (Exception e){
            return null;
        }
    }
}
