// Filename: router.js
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/vLogin',
    'views/vMy',
    'views/vProfile',
    'views/vSearch',
    'views/vEditInfo',
    'views/vGrup'
], function($, _, Backbone,Bootstrap,Login,My,vProfile,vSearch,vEditInfo,vGrup){

    var AppRouter = Backbone.Router.extend({
        routes: {
            "login": "showLogin",
            "my": "showMy",
            "profile": "showProfile",
            "profile/:id": "showProfileById",
            "group/:id": "showGrupById",
            "search/:text": "showSearch",
            "edit": "showEdit"
        },

        initialize : function(){


            var json = $.ajax({
                url : "/rest/auth/init",
                type : "POST",
                dataType : "json"

            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){
                    var my = new My();
                }else{
                    var login = new Login();
                }
            }).fail(function( response ) {

                var login = new Login();
            });



        },

        showLogin : function(){
            var login = new Login();
        },

        showMy : function(){
            var my = new My();
        },

        showProfile : function(){
            var vprofile = new vProfile();
            vprofile.render(null)
        },
        showProfileById : function(id){
            var vprofile = new vProfile();
            vprofile.render(id);
        },

        showGrupById : function(id){
            var vgrup = new vGrup();
            vgrup.render(id);
        },

        showSearch : function(text){
            var vsearch = new vSearch();
            vsearch.render(text);
        },

        showEdit : function(){
           var _veditInfo = new vEditInfo();
            _veditInfo.render();
        }

    });

    Backbone.history.start();

    return AppRouter;
});