/**
 * Created by marc on 22/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/edit/tGrupEdit.html',
    'text!../../../modal/modalDefould.html',
    'text!../../../modal/Grup/modalCrear.html',
    '../utils/AutocompleteUsers',
    'views/vMsg',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,tGrupEdit,modalDefould,modalCrear,AutocompleteUsers,vMsg,vVarTime){

    var vAdminGrup = Backbone.View.extend({

        events: {
            "click #idGrupEditCrearGrup": "openModalCrearGrup"
        },

        initialize : function(){
            $('#modalApp').modal('hide');
        },

        render: function(){

            this.$el.append( _.template(tGrupEdit, {}));

        },

        openModalCrearGrup : function(){
            $('#modalApp').modal({});

            var self = this;
            var btnDone = '<button type="button" class="btn btn-default">Crear</button>';
            //remove modal
            $('#modalApp').html("");

            //init modal
            $('#modalApp').append(_.template(modalDefould, {}));
            $('#modalApp').find('.modal-title:first').html("Creació de Grup");
            $('#modalApp').find('.modal-body:first').html(_.template(modalCrear, {}));



            $('#modalApp').find("#uploadedfile").on("change", function(){
                var file = this.files[0],
                    fileName = file.name,
                    fileSize = file.size;

                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#modalApp').find('#imguploadedfile')
                        .attr('src', e.target.result)
                        .width(100)
                        .height(100);
                };

                reader.readAsDataURL(file);

                //alert("Uploading: "+fileName+" @ "+fileSize+"bytes");
                //CustomFileHandlingFunction(file);
            });

            var autocomplete = new AutocompleteUsers({
                el: $('#modalApp').find('#iddivModalCreacioGrupAutocompleteUsers')});

            $('#idModalFundat').datetimepicker({
                lang:'cat',
                timepicker:false,
                format:'d/m/Y'});

            $('#modalApp').find('.modal-footer:first')
                .find('button:first').html("Crear");


            $('#modalApp').find('.modal-footer:first')
                .find('button:first')
                .click(function(){

                    if(self.check()){

                        var array = autocomplete.getArray();
                        var arrayString = "";

                        for (x=0;x<array.length;x++){
                            arrayString += array[x] + ",";
                        }
                        var img = $('#modalApp').find("#imguploadedfile");

                        var vartime = new vVarTime();
                        vartime.render();
                        var json = $.ajax({
                            url : "/rest/grup",
                            type : "POST",
                            dataType : "json",
                            data : {
                                name : $('#idModalCrearNomGrup').val(),
                                description : $('#idModalCrearDescription').val(),
                                founded : $('#idModalFundat').val(),
                                styleMusica : $('#idModalCrearEstil').val(),
                                members : arrayString,
                                photo : img.attr('src')

                            }
                        }).done(function( response, status, jqXHR ) {
                            vartime.quit();

                            if(response.state == "OK"){
                                $('#modalApp').modal('hide');
                                window.location.href = "/#group/"+response.id;

                                var msg = new vMsg();
                                msg.render('<div class="green-color">' +
                                    '<span class="glyphicon glyphicon-ok"></span>' +
                                    '&nbsp;s\'ha creat el grup.</div>');

                            }else{

                                var msg = new vMsg();
                                msg.render('<div class="color-error">' +
                                    '<span class="glyphicon glyphicon-remove"></span>' +
                                    '&nbsp;s\'ha produit un error.</div>');
                            }


                        }).fail(function( response ) {
                            vartime.quit();

                            var msg = new vMsg();
                            msg.render('<div class="color-error">' +
                                '<span class="glyphicon glyphicon-remove"></span>' +
                                '&nbsp;s\'ha produit un error.</div>');
                        });
                    }


                });

        },

        check : function(){

            var rtn = true;
            var name = $('#idModalCrearNomGrup').val();
            var description = $('#idModalCrearDescription').val();
            var founded = $('#idModalFundat').val();
            var styleMusica = $('#idModalCrearEstil').val();

            if(name != null && name != ""){

            }else{
                rtn = false;
            }

            return rtn;
        }

    });


    return vAdminGrup;
});

