/**
 * Created by marc on 29/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../../templates/grup/tConfigGrupMembers.html',
    'views/utils/AutocompleteUser',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,template,AutocompleteUser,vVarTime){

    var view = Backbone.View.extend({

        initialize : function(){
            this.render();
        },

        render: function(){
            var self = this;
            this.$el.html("");
            this.$el.append( _.template( template, {}));
            this.printMembers();
        },

        printMembers : function(){
            var self = this;
            var members = this.model.users;

            for(var i in members){

                var member = members[i];

                this.printMember(member);
            }

            if(this.model.member =="FOUNDER" || this.model.member == "ADMIN"){

                var spanAdd = '<div class="col-md-12"><span class="glyphicon glyphicon-plus green-color"></span></div>';
                this.$el.append(spanAdd);
                this.$el.find('.glyphicon-plus').click(function(){
                    $(this).hide();
                    self.addUser();
                });
            }

        },

        printMember : function(member){
            var self = this;

            var rolname = member.rol == null ? "" : member.rol;
            var memberId = member.id;
            var memberName = member.name;
            var option = "";

            if((this.model.member =="FOUNDER" || this.model.member == "ADMIN") && member.typeMember != "FOUNDER"){

                option += '<select class="ItemselectMember displayinline">' +
                    '<option value="ADMIN">Admin</option>' +
                    '<option value="BASIC">Bàsic</option>' +
                    '</select>';
               option += '<span class="glyphicon glyphicon-remove red-color"></span>';
            }

            option += ' <small><a>Guardar</a></small>';

            this.$el.append('<div class="col-md-12"><div class="col-md-4">'+memberName+'</div>' +
                '<div class="col-md-3">' +
                '<input type="text" class="Iteminput sizeXXSmall" id="idModalCrearNomGrup" value="'+rolname+'"  placeholder="Rol">' +
                '</div>' +
                '<div class="col-md-5">' +
                option +
                '</div>' +
                '</div>');

            var select = this.$el.find('div:last').find('select:last option[value="'+member.typeMember+'"]')
                .prop('selected', true);

            var remove = this.$el.find('div:last').find('span:last');
            remove.click(function(){

                var username = remove.parent().parent().find('div:first').html();
                var json = $.ajax({
                    url : "/rest/grup/member/"+self.model.id+"/"+member.id,
                    type : "DELETE",
                    dataType : "json",
                    data : {
                    }
                }).done(function( response, status, jqXHR ) {

                    self.model = response;
                    self.render();

                }).fail(function( response ) {
                    alert("error");
                });
            });

            var save = this.$el.find('div:last').find('a:last');
            save.click(function(){

                var username = save
                    .parent().parent().parent()
                    .find('div').eq(0).html();

                var rol = save
                    .parent().parent().parent()
                    .find('div').eq(1).find('input:last')
                    .val();


                var select1 = save.parent().parent()
                    .find('select:last')

                var type = select1.val();

                var vartime = new vVarTime();
                vartime.render();
                var json = $.ajax({
                    url : "/rest/grup/member/"+self.model.id,
                    type : "PUT",
                    dataType : "json",
                    data : {
                        memberId : member.id,
                        rol : rol,
                        type : type
                    }
                }).done(function( response, status, jqXHR ) {
                    vartime.quit();

                    self.model = response;
                    self.render();

                }).fail(function( response ) {
                    vartime.quit();
                });

            });



        },

        addUser : function(){

            var self = this;
            var userId = null;
            var spanSend = '<span class="glyphicon glyphicon-send blue-color"></span>';

            this.$el.append('<div class="col-md-12">' +
                '<div class="col-md-4"><input type="text" class="Iteminput sizeXSmall" id="idInputNameAddUser"  placeholder="Nom "></div>' +
                '<div class="col-md-4"><input type="text" class="Iteminput sizeXSmall" id="idInputRolAddUser" placeholder="Rol"></div>' +
                '<div class="col-md-3">'+spanSend+'</div>' +
                '</div>');
            var input = this.$el.find('div:last').parent().find('#idInputNameAddUser');
            var inputRol = this.$el.find('div:last').parent().find('#idInputRolAddUser');
            this.$el.find('span:last').click(function(){

                $(this).hide();
                var rol = inputRol.val();

                var vartime = new vVarTime();
                vartime.render();
                var json = $.ajax({
                    url : "/rest/grup/member/"+self.model.id,
                    type : "POST",
                    dataType : "json",
                    data : {
                        userId : auto.getModel().id,
                        rol : rol
                    }
                }).done(function( response, status, jqXHR ) {
                    vartime.quit();

                    if(response.state == "OK"){

                        self.model = response;
                        self.render();
                    }


                }).fail(function( response ) {
                    vartime.quit();
                });
            });

            this.$el.append('<div></div>');
            var auto = new AutocompleteUser({el: this.$el.find('div:last')});
            auto.render(input);

        }

    });

    return view;

});
