/**
 * Created by marc on 29/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/grup/modal/vModalConfigGeneral',
    'views/grup/modal/vModalConfigMembres',
    'text!../../../templates/grup/tButtonsMember.html',
    'text!../../../modal/modalDefould.html',
    'text!../../../modal/Grup/modalConfigGrup.html'
], function($, _, Backbone,Bootstrap,vModalConfigGeneral,vModalConfigMembres,
            tButtonsMember,modalDefould,modalConfigGrup){

    var btn = Backbone.View.extend({

        initialize : function(){
            this.render();
        },

        render: function(){
            var self = this;
            this.$el.html("");
            this.$el.append( _.template( tButtonsMember, {}));


            if(self.model == null){
                var json = $.ajax({
                    url : "/rest/grup/"+self.model.id,
                    type : "GET",
                    dataType : "json"
                }).done(function( response, status, jqXHR ) {

                    if(response.state == "OK"){
                        self.model = response;
                    }
                }).fail(function( response ) {

                });
            }


            var config = this.$el.find('.glyphicon-cog:first');
            config.click(function(){
                self.openModal();
            });

            var post = this.$el.find('.glyphicon-edit:first');
            post.click(function(){
                var post = new vModelTextAreaPostGrup({model : self.model});
            });
        },

        openModal : function(){
            var self = this;
            try{

                //remove modal
                $('#modalApp').html("");
                var btnDone = '<button type="button" class="btn btn-default">Guardar</button>';

                //init modal
                $('#modalApp').append(_.template(modalDefould, {}));
                $('#modalApp').find('.modal-title:first').html("Configuració Grup");
                $('#modalApp').find('.modal-body:first').html(_.template(modalConfigGrup, {}));
                $('#modalApp').find('.modal-footer:first').prepend(btnDone);

                $('#modalApp').modal({});
                self.showGeneral();

                var btnNavGeneral = $('#idModalConfigModalGeneral');
                btnNavGeneral.click(function(){self.showGeneral()});

                var btnNavMembres = $('#idModalConfigModalMembres');
                btnNavMembres.click(function(){self.showMembres()});
                $('#idConfigModalMembres').hide();

                var general = new vModalConfigGeneral({el : $('#idConfigModalGeneral'),model : self.model});
                var general = new vModalConfigMembres({el : $('#idConfigModalMembres'),model : self.model});

            }catch (err){}
        },

        showGeneral : function(){

            var btnSEnd = $('#modalApp').find('.modal-footer:first').find('button:first');
            var btnNavGeneral = $('#idModalConfigModalGeneral');
            var btnNavMembres = $('#idModalConfigModalMembres');
            var divGeneral = $('#idConfigModalGeneral');
            var divMembres = $('#idConfigModalMembres');

            btnNavMembres.removeClass('active');
            btnNavGeneral.addClass('active');

            divMembres.hide();
            divGeneral.show();
            btnSEnd.show();

        },
        showMembres : function(){
            var btnSEnd = $('#modalApp').find('.modal-footer:first').find('button:first');
            var btnNavGeneral = $('#idModalConfigModalGeneral');
            var btnNavMembres = $('#idModalConfigModalMembres');
            var divGeneral = $('#idConfigModalGeneral');
            var divMembres = $('#idConfigModalMembres');

            btnNavGeneral.removeClass('active');
            btnNavMembres.addClass('active');
            divGeneral.hide();
            divMembres.show();
            btnSEnd.hide()
        }

    });

    return btn;

});
