/**
 * Created by marc on 29/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/grup/tButtonsUserAuth.html'
], function($, _, Backbone,Bootstrap,tButtonsUserAuth){

    var btn = Backbone.View.extend({

        initialize : function(){
        },

        render: function(view){
            this.$el.html("");
            this.$el.append( _.template( tButtonsUserAuth, {}));

            if(this.model.follow){
                this.follower(view);

            }else{
                this.not_follower(view);
            }

        },

        follower : function(view){

            var icon = this.$el.find('.glyphicon-heart-empty');
            icon.parent().addClass('red-color');

            icon.hover(function(){
                icon.removeClass("glyphicon-heart-empty red-color");
                icon.addClass('glyphicon-remove red-color');

            },function(){
                icon.removeClass("glyphicon-remove red-color");
                icon.addClass('glyphicon-heart-empty red-color');
            });

            this.noFollow(icon,view);

        },

        not_follower : function(view){

            var icon = this.$el.find('.glyphicon-heart-empty').parent();
            icon.addClass('follow');
            this.follow(icon,view);

        },

        follow : function(item,view){

            var grupId = this.model.id;

            var self = this;
            item.click(function(){

                var friendsJNSON = $.ajax({
                    url : "rest/grup/follow",
                    type : "PUT",
                    dataType : "json",
                    data : {
                        grupId : grupId,
                        follow : true
                    }
                }).done(function(response, status, jqXHR){

                    if(response.state == "OK"){

                        if(view != null){
                            view.render(response.id);
                        }

                        self.model = response;
                        self.render();

                    }
                }).fail(function(response){

                });
            });
        },

        noFollow : function(icon,view){

            var item = icon.parent();
            var grupId = this.model.id;

            var self = this;
            item.click(function(){

                var friendsJNSON = $.ajax({
                    url : "rest/grup/follow",
                    type : "PUT",
                    dataType : "json",
                    data : {
                        grupId : grupId,
                        follow : false
                    }
                }).done(function(response, status, jqXHR){

                    if(response.state == "OK"){
                        if(view != null){
                            view.render(response.id);
                        }

                        self.model = response;
                        self.render();

                    }
                }).fail(function(response){

                });
            });

        }
    });

    return btn;

});
