/**
 * Created by marc on 12/05/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/grup/vSCTrack',
    'text!../../../templates/grup/tSCList.html',
    'views/vMsg',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,vSCTrack,tSCList,vMsg,vVarTime){

    var view = Backbone.View.extend({

        initialize : function(){
            this.render();
        },

        render: function(){
            var self = this;

            var option = "";
            if(this.model.soundcloud != null){

                if(this.model.member == "ADMIN" || this.model.member == "FOUNDER"){
                    option = '<div class="boxAddSong">' +
                        '<input type="text" class="Iteminput  width100" name="url" placeholder="Posa una nova cançó...">'+
                        '</div>';
                }

                this.$el.prepend( _.template( tSCList,{option : option}) );

                this.$el = this.$el.find('div:first');
                var footer = this.$el.find('.footer:last');
                self.addSong(footer);

                this.printList(this.$el);


            }else if(this.model.member == "ADMIN" || this.model.member == "FOUNDER"){

                    //TODO: pot pujar cançons

                option = '<small><a><span class="glyphicon glyphicon-plus">&nbsp;Posar una cançó</span></a></small>';
                this.$el.prepend( _.template( tSCList,{option : option}) );

                this.$el = this.$el.find('div:first');

                var footer = this.$el.find('.footer:last');
                self.addSong(footer);
            }
        },


        printList : function(divCançons){
            var self = this;
            var principal = divCançons.find('.principalTrack').eq(0);
            var llista = divCançons.find('.ListTrack').eq(0);

            principal.html("");
            llista.html("");

            for(var i in self.model.soundcloud){

                var song = self.model.soundcloud[i];

                if(i == 0){
                    principal.append(song.iframe);

                    var SCsong = new vSCTrack({el:llista, model : song});
                    SCsong.render(principal);

                }else{
                    var SCsong = new vSCTrack({el:llista, model : song});
                    SCsong.render(principal);

                }
            }



        },


        addSong : function(footer){
            var self = this;

            footer.find('input:last').keypress(function(event){
                var keycode = (event.keyCode ? event.keyCode : event.which);

                var input = $(this);
                if(keycode == '13'){

                    SC.initialize({
                        client_id: "0fa867c152948e85740c2448210510e7"
                    });


                    SC.oEmbed(input.val(), {auto_play: false,
                        show_comments: false,
                        sharing : false,
                        show_artwork: true,
                        maxheight: 200}, function(oEmbed) {
                        self.putSong(input,oEmbed);
                    });


                }
            });
        },

        putSong : function(input,oEmbed){

            var self = this;
            if(oEmbed == null){return null;}

            var grupId = this.model.id;
            var name = oEmbed.title + " - " + oEmbed.author_name;
            var iframe = oEmbed.html;
            var url = input.val();

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/soundcloud",
                type : "POST",
                dataType : "json",
                data : {
                    grupId : grupId,
                    name : name,
                    iframe : iframe,
                    url : url
                }
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    input.val("");

                    self.model.soundcloud = response.list;
                    self.printList(self.$el);

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;s\'ha publicat amb èxit.</div>');
                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;Error en la publicació del comentari.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();

                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;Error en la publicació del comentari.</div>');

            });

        }
    });

    return view;

});
