/**
 * Created by marc on 08/05/14.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'models/mLogin',
    'text!../../../templates/login/tVarLogin.html',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,mLogin,tVarLogin,vVarTime){

    var Login = Backbone.View.extend({

        el: $('#varApp'),

        events: {
            "click #btnsubmitLogin": "login"
        },

        initialize : function(){
            $('#varApp').html("");
            this.render();

        },

        render: function(){

            var self = this;
            $(this.el).html("");
            this.$el.append( _.template( tVarLogin, {} ) );

            this.$el.find("#inputEmail_log").focus();

            this.$el.find("#inputEmail_log").keypress(function(event){
                var keycode = (event.keyCode ? event.keyCode : event.which);
                if(keycode == '13'){
                    self.login();
                }
            });

            this.$el.find("#inputPassword_log").keypress(function(event){
                var keycode = (event.keyCode ? event.keyCode : event.which);
                if(keycode == '13'){
                    self.login();
                }
            });


        },


        login : function(){
            var email =  $("#inputEmail_log").val();
            var pwd = $("#inputPassword_log").val();

            var mlogin = new mLogin();

            mlogin.contruct(email,pwd);

            if(!mlogin.check()){return;}

            var vartime = new vVarTime();
            vartime.render();

            var json = $.ajax({
                url : "/rest/auth",
                type : "POST",
                dataType : "json",
                data : mlogin.jsonData()
            }).done(function( response, status, jqXHR ) {
                vartime.quit();
                if(response.state == "OK"){
                    $("#msgError_log").text("");
                    window.location.href = "/#my";
                }else{
                    $("#divemail_log").addClass("has-error");
                    $("#divpwd_log").addClass("has-error");
                    $("#msgError_log").text(response.message);
                }
            }).fail(function( response ) {
                vartime.quit();
                $("#msgError_log").text("Error del servidor");
            });
        }

    });

    return Login;

});