/**
 * Created by marc on 28/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/notifications/tItemNotification.html',
    'text!../../../templates/notifications/tItemNotification2.html'
], function($, _, Backbone,Bootstrap,tItemNotification,tItemNotification2){

    var vItemNotifications = Backbone.View.extend({

        events: {
            "click" : "thisclick"
        },

        initialize : function(){
            this.$el.html("");
            this.render();
        },

        render: function(){
            this.$el.html("");
            var self = this;
            var text = "";

            switch(this.model.typeNotifications){

                case "GRUP_MEMBER":
                    text += this.model.text + " de <strong>" + this.model.grupFrom.name + "</strong>";

                    break;
                case "GRUP":
                    text += this.model.text +'<strong>' + this.model.grupFrom.name + '</strong>';

                    break;
                case "FOLLOW":
                    text += '<strong>' +this.model.userFrom.name + '</strong>' + this.model.text;

                    break;
                case "FOLLOW_GRUP":
                    text += '<strong>' +this.model.userFrom.name + '</strong>' + this.model.text +
                        "<strong>" + this.model.grupTo.name + "</strong>";

                    break;
                case "FRIEND_POST":
                    text += '<strong>' +this.model.userFrom.name + '</strong>' + this.model.text;

                    break;
                case "NO_FRIEND_POST":
                    text += '<strong>' +this.model.userFrom.name + '</strong>' + this.model.text;

                    break;
                case "GRUP_POST":
                    text += '<strong>' +this.model.grupTo.name + '</strong>' + this.model.text;

                    break;
                case "SYSTEM_EDIT_PROFILE":
                    text += '<strong>SocialSong</strong> ' + this.model.text;

                    break;
                default:
                    text += this.model.text;
            }

            var options = "";

            if(this.model.status == "PENDING"){

                options += '<button ctype="button" class="btn btn-info btn-xs btnNotificacion">Acceptar</button>' +
                    '<button type="button" class="btn btn-danger btn-xs btnNotificacion">Denegar</button>';
            }

            var date = this.model.date;
            var isnew = "";

            if(this.model.isNew){
                isnew = '<span class="label label-default spanPadding">Nou</span>';
            }

            if(options != ""){
                var compiledTemplate = _.template( tItemNotification2, {isnew : isnew, text : text,options: options, date : date} );

            }else{
                var compiledTemplate = _.template( tItemNotification, {isnew : isnew, text : text,options: options, date : date} );
            }

            this.$el.append(compiledTemplate);

            this.$el.find('button').eq(0).click(function(){

                var json = $.ajax({
                    url : "/rest/notifications/"+self.model.id,
                    type : "PUT",
                    dataType : "json",
                    data:{
                        option : true,
                        isnew : false
                    }
                }).done(function( response, status, jqXHR ) {

                    if(response.state == "OK"){
                        self.model = response;
                        self.$el.hide();
                    }
                    self.$el.hide();
                }).fail(function( response ) {
                    self.$el.hide();

                });

            });

            this.$el.find('button').eq(1).click(function(){

                var json = $.ajax({
                    url : "/rest/notifications/"+self.model.id,
                    type : "PUT",
                    dataType : "json",
                    data:{
                        option : false,
                        isnew : false
                    }
                }).done(function( response, status, jqXHR ) {

                    if(response.state == "OK"){
                        self.$el.remove();
                    }
                }).fail(function( response ) {

                });
            });

        },

        update : function(){
            var self = this;

            var json = $.ajax({
                url : "/rest/notifications/"+this.model.id,
                type : "GET",
                dataType : "json",
                data:{
                    isnew : false
                }
            }).done(function( response, status, jqXHR ) {

                self.model = response;
                self.render();

            }).fail(function( response ) {

            });



        },

        thisclick : function(){

            //FOLLOW,FOLLOW_GRUP,FRIEND_POST,NO_FRIEND_POST,GRUP_POST, SYSTEM_EDIT_PROFILE

            var json = $.ajax({
                url : "/rest/notifications/"+this.model.id,
                type : "PUT",
                dataType : "json",
                data:{
                    isnew : false
                }
            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){}
            }).fail(function( response ) {

            });

            switch(this.model.typeNotifications){
                case "GRUP_MEMBER":
                    if(this.model.status == "PENDING"){

                    }else{
                        window.location.href = "#group/"+this.model.grupFrom.id;
                    }
                    break;
                case "GRUP":
                    window.location.href = "#group/"+this.model.grupFrom.id;
                    break;
                case "FOLLOW":
                    window.location.href = "/#profile/"+this.model.idFrom;
                    break;
                case "FOLLOW_GRUP":
                    window.location.href = "/#profile/"+this.model.idFrom;
                    break;
                case "FRIEND_POST":
                    window.location.href = "/#profile/"+this.model.idFrom;
                    break;
                case "NO_FRIEND_POST":
                    window.location.href = "/#profile/"+this.model.idFrom;
                    break;
                case "GRUP_POST":
                    window.location.href = "#group/"+this.model.idFrom;
                    break;
                case "SYSTEM_EDIT_PROFILE":
                    window.location.href = "/#edit";
                    break;
                default:
            }

        }

    });


    return vItemNotifications;
});


