/**
 * Created by marc on 10/05/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/vMsg',
    'views/utils/vVarTime'

], function($, _, Backbone,Bootstrap,vMsg,vVarTime){

    var vTextBox = Backbone.View.extend({

        events: {
        },

        initialize : function(){
            this.$el.html("");
        },

        render: function(show,view){
            this.$el.html("");
            var self = this;

            if(!show){
                this.$el.hide();
            }

            this.$el.addClass('commentary');
            var img = "";
            if(this.model.img != null){

                img = '<img class="imagePost" src="data:image/png;base64,'+this.model.img+'">';
            }else{

                img = '<img class="imagePost" src="/img/defould.png">';

            }



            var name = "";

            if (this.model.type == "USER"){
                name = '<a class="commentaryName" href="#profile/'+this.model.idCommentarist+'">'+this.model.name+'</a>';

            }else if (this.model.type == "GRUP"){
                name = '<a class="commentaryName" href="#group/'+this.model.idCommentarist+'">'+this.model.name+'</a>';
            }
            var options = "";

            if(this.model.like != null && this.model.like){
                options += '<div class="option"><a>'+this.model.nLike+'&nbsp;' +
                    '<span class="glyphicon glyphicon-thumbs-up blue-color"></span></a></div>';
            }else{
                options += '<div class="option"><a>'+this.model.nLike+'&nbsp;' +
                    '<span class="glyphicon glyphicon-thumbs-up "></span></a></div>';
            }

            this.$el.append('<div class=" col-md-10 col-md-offset-1"><div class="col-md-2">' +
                img +
                '</div>' +
                '<div class="col-md-9">' +
                '<div >'+name+'</div>' +
                '<div class="commentaryText">'+this.model.text+'</div>' +
                '<div class="commentaryOptions"><small><div class="postDate">'+this.model.date+'</div>' +
                '<div class="option"><a>respondre</a></div>'+options+'</small></div>' +
                '</div>' +
                '</div>');

            var response = this.$el.find('.option').eq(0);
            var like = this.$el.find('.option').eq(1).find('a:last');

            var _img = this.$el.find('div').eq(0).find('div').eq(0).find('img').eq(0);

            //var cw = _img.width();
            _img.css({'width':'65px'});
            _img.css({'height':'65px'});

            response.click(function(){
                view.doResponse();
            });

            like.click(function(){

                self.like(view);

            });

            like.hover(function(){

                if(self.model.like != null && self.model.like){
                    $(this).find('span:last').removeClass('glyphicon-thumbs-up');
                    $(this).find('span:last').addClass('glyphicon-thumbs-down');
                }else{
                    $(this).find('span:last').addClass('blue-color');
                }
            },function(){

                if(self.model.like != null && self.model.like){
                    $(this).find('span:last').removeClass('glyphicon-thumbs-down');
                    $(this).find('span:last').addClass('glyphicon-thumbs-up');
                }else{
                    $(this).find('span:last').removeClass('blue-color');
                }
            });

        },

        like : function(view){
            var self = this;
            var like = true;

            if(this.model.like != null && this.model.like){
                like = false;
            }else{
                like = true;
            }

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/like",
                type : "PUT",
                dataType : "json",
                data : {
                    //postId : self.model.id,
                    commentaryId : self.model.id,
                    like : like
                }
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    self.update(response,view);

                    self.render(true,view);

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;.</div>');
                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;Error en la actualització.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();

                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;Error en la actualització.</div>');

            });

        },

        update : function(post,view){

            var self = this;
            var i = 0;
            var trobat = false;

            while( i < post.commentaryTOList.length && !trobat){
                var commentary = post.commentaryTOList[i]

                if(commentary.id == self.model.id){

                    trobat = true;
                    self.model = commentary;
                }

                i++;
            }

            if(trobat){
                self.render(true,view);
            }
        }

    });


    return vTextBox;
});

