/**
 * Created by marc on 31/03/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/post/tPost.html',
    'views/post/vCommentary',
    'views/vMsg',
    'views/utils/vModalList',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,tPost,vCommentary,vMsg,vModalList,vVarTime){

    var vPost = Backbone.View.extend({

        events: {
        },

        initialize : function(){
            this.$el.html("");
        },

        render: function(view){

            this.$el.html("");
            var self = this;
            this.$el.addClass('post');

            var nameForImg = "";
            var from = "";
            var to = "";
            var symbol = "&nbsp;&raquo;&nbsp;";
            var option = "";
            var textpostShare = "";

            if(this.model.postShare != null){

                if(this.model.grupFrom != null){
                    textpostShare = '<div class="textPostShare">Compartit per ' +
                        '<a href="#group/'+this.model.grupFrom.id+'">'+
                        this.model.grupFrom.name + '</a></div>';

                }else if(this.model.userFrom != null){
                    textpostShare = '<div class="textPostShare">Compartit per <a href="#profile/'+
                        this.model.userFrom.id +'">'+
                        this.model.userFrom.name + ' ' +
                        this.model.userFrom.secondname +'</a></div>';
                }

                if(!this.isForOwn(this.model.postShare) &&
                    this.model.postShare.userTo != null){
                    to = '<a class="aPost" href="#profile/'+
                        this.model.postShare.userTo.id+'">'+this.model.postShare.userTo.name +
                        " " + this.model.postShare.userTo.secondname+'</a>';

                }else if(!this.isForOwn(this.model.postShare) &&
                    this.model.postShare.grupTo != null){
                    to = '<a class="aPost" href="#group/'+
                        this.model.postShare.grupTo.id+'">'+this.model.postShare.grupTo.name+'</a>';

                }else{ symbol = ""}

                if(this.model.postShare.grupFrom != null){
                    from = '<a class="aPost" href="#group/'+
                        this.model.postShare.grupFrom.id+'">'+this.model.postShare.grupFrom.name+'</a>';
                    nameForImg = this.model.postShare.grupFrom.name;

                }else if(this.model.postShare.userFrom != null){
                    from = '<a class="aPost" href="#profile/'+
                        this.model.postShare.userFrom.id+'">'+this.model.postShare.userFrom.name +
                        " " + this.model.postShare.userFrom.secondname+'</a>';
                    nameForImg = this.model.postShare.userFrom.name;
                }

            }else{

                if(!this.isForOwn(this.model) && this.model.userTo != null){
                    to = '<a class="aPost" href="#profile/'+
                        this.model.userTo.id+'">'+this.model.userTo.name + " " + this.model.userTo.secondname+'</a>';

                }else if(!this.isForOwn(this.model) && this.model.grupTo != null){
                    to = '<a class="aPost" href="#group/'+
                        this.model.grupTo.id+'">'+this.model.grupTo.name+'</a>';

                }else{ symbol = ""}


                if(this.model.grupFrom != null){
                    from = '<a class="aPost" href="#group/'+
                        this.model.grupFrom.id+'">'+this.model.grupFrom.name+'</a>';
                    nameForImg = this.model.grupFrom.name;

                }else if(this.model.userFrom != null){
                    from = '<a class="aPost" href="#profile/'+
                        this.model.userFrom.id+'">'+this.model.userFrom.name + " " + this.model.userFrom.secondname+'</a>';
                    nameForImg = this.model.userFrom.name;
                }

            }


            option = this.putOptions();
            var OriginaText = this.model.text;
            var text = this.rederText(this.model.text);


            var compiledTemplate = _.template( tPost, {
                postShare : textpostShare,
                from : from,
                symbol : symbol,
                to : to,
                text : text,
                date : this.model.date,
                options : option} );

            this.$el.append( compiledTemplate );

            this.putHref(nameForImg);


            var song = this.$el.find('.songs').eq(0);

            var code = this.check(OriginaText);

            if(code != null && code != ""){
                song.prepend('<iframe class="vidioYoutube" '+
                    'src="http://www.youtube.com/embed/'+code+'">'+
                    '</iframe>');
            }

            var url = this.checkSoundCloud(OriginaText);

            if(self.model.scTrackTO != null){

                song.append(self.model.scTrackTO.iframe);

            }else if(url != null && url != ""){
                self.getIframeSoundCloud(url,song);
            }

            this.putOnClickOptions(view);

            this.printListCommentary(this.model.commentaryTOList);

            this.HashTagsClick();

        },

        HashTagsClick : function(){
            var self = this;


            var text = this.$el.find('.posttext:first').find('p:first');
            text.find('a').each(function(index){

                var value =$(this).html();

                if(value != null && value != "" &&
                    value.length > 1 && value.substring(0,1) == "#"){

                    $(this).click(function(){

                        var value2 = value.substring(1,value.length);
                        var json = $.ajax({
                            url : "/rest/post/hashtag/"+ value2,
                            type : "GET",
                            dataType : "json"
                        }).done(function( response, status, jqXHR ) {
                            if(response.state == "OK"){
                                var modalList = new vModalList();
                                modalList.render(response.list,value);
                            }

                        }).fail(function( response ) {


                        });

                    });
                }
            });
        },

        putOptions : function(){

            var options = "";

            //respostes
            if(this.model.permit == "R_S" ||
                this.model.permit == "R__" ||
                this.model.permit == "RWS" ||
                this.model.permit == "RW_"){


                var nCommetary = 0;

                if(this.model.commentaryTOList != null){
                    nCommetary = this.model.commentaryTOList.length;
                }
            options += '<div class="option"><a>' +
                nCommetary +'&nbsp;<span class="glyphicon glyphicon-comment"></span>' +
                '</a></div>';
            }

            //Compartir
            if(this.model.permit == "R_S" ||
                this.model.permit == "__S" ||
                this.model.permit == "RWS" ||
                this.model.permit == "_WS"){

                options += '<div class="option"><a>compartir</a></div>';
            }

            //respondre
            if(this.model.permit == "_WS" ||
                this.model.permit == "RWS" ||
                this.model.permit == "_W_" ||
                this.model.permit == "RW_"){

                options += '<div class="option"><a>respondre</a></div>';

                if(this.model.like != null && this.model.like){
                    options += '<div class="option"><a>'+this.model.nLike+'&nbsp;' +
                        '<span class="glyphicon glyphicon-thumbs-up blue-color"></span></a></div>';
                }else{
                    options += '<div class="option"><a>'+this.model.nLike+'&nbsp;' +
                        '<span class="glyphicon glyphicon-thumbs-up "></span></a></div>';
                }

            }


            return options;
        },

        rederText : function(pText){
            if(pText == null || pText == ""){
                return "";
            }
            var MAXLENGTH = 65;

            var text = "";
            var mySplitResult = pText.split(" ");
            for(x = 0; x < mySplitResult.length; x++){

                if (mySplitResult[x].length > MAXLENGTH) {
                    while(mySplitResult[x].length > MAXLENGTH){
                        var aux = mySplitResult[x].substring(0,MAXLENGTH);
                        mySplitResult[x] = mySplitResult[x].substring(MAXLENGTH+1,mySplitResult[x].length);
                        text += aux + " ";
                    }
                }else{
                    text += mySplitResult[x] + " ";
                }
            }

            text = this.checkHashTag(text);
            text = this.checkUrls(text);

            return text;
        },

        checkUrls : function(text){

            if(text == null){return "";}

            text.trim();

            var newText = "";
            var words = text.split(" ");

            if(words == null){return text;}

            for(var i in words){

                var newWord = "";
                var word = words[i];

                if(word != null &&
                    word != "" &&
                    (word.indexOf("http://www.") == 0 ||
                    word.indexOf("https://") == 0 ||
                    word.indexOf("https://www.") == 0 )){

                    newWord = '<a href="'+word+'">'+word+'</a>';

                }else if(word != null &&
                    word != "" &&
                    word.indexOf("www.") == 0){
                    newWord = '<a href="http://'+word+'">'+word+'</a>';

                }else{
                    newWord = word;
                }

                newText += newWord;

                if(i != words.length -1){
                    newText += " ";
                }
            }

            return newText;




        },

        checkHashTag : function(text){

            if(text == null){return "";}

            text = text.trim();

            var newText = "";
            var words = text.split(" ");

            if(words == null){return text;}

            for(var i in words){

                var newWord = "";
                var word = words[i];

                if(word != null &&
                    word != "" &&
                    word.length > 1 &&
                    word.substring(0,1) == "#"){

                    newWord = '<a>'+word+'</a>';

                }else{
                    newWord = word;
                }

                newText += newWord;

                if(i != words.length -1){
                    newText += " ";
                }
            }
            newText = newText.trim();
            return newText;
        },

        setEl : function(el){
            this.$el = el;
        },

        borrar : function(){

            if(confirm('Seguro que quiere eliminar la publicacion?')){

                var self = this;
                var json = $.ajax({
                    url : "/rest/post/my/"+self.model.id,
                    type : "DELETE",
                    dataType : "json"
                }).done(function( response, status, jqXHR ) {
                    if(response.state == "OK"){
                        self.$el.hide();
                    }

                }).fail(function( response ) {

                });
            }
        },

        compartir : function(view){

            var self = this;

            var vartime = new vVarTime();
            vartime.render();
                var json = $.ajax({
                    url : "/rest/post/share",
                    type : "POST",
                    dataType : "json",
                    data : {
                        id : self.model.id
                    }
                }).done(function( response, status, jqXHR ) {
                    vartime.quit();

                    if(response.state == "OK"){
                        view.PrintFirstPost(response);

                        var msg = new vMsg();
                        msg.render('<div class="green-color">' +
                            '<span class="glyphicon glyphicon-ok"></span>' +
                            '&nbsp;s\'ha compartit amb èxit.</div>');

                    }else{

                        var msg = new vMsg();
                        msg.render('<div class="color-error">' +
                            '<span class="glyphicon glyphicon-remove"></span>' +
                            '&nbsp;s\'ha produit un error.</div>');
                    }

                }).fail(function( response ) {
                    vartime.quit();
                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;s\'ha produit un error.</div>');

                });
        },

        isForOwn : function(post){

            if(post.userTo != null &&
                post.userFrom != null &&
                post.userTo.id == post.userFrom.id){
                return true;
            }

            if(post.grupTo != null &&
                post.grupFrom != null &&
                post.grupTo.id == post.grupFrom.id){
                return true;
            }

            return false;
        } ,

        putHref:function(from){
            var self = this;

            var _img = this.$el.find('img:last');

            var src = "";

            if(this.model.grupFrom != null){

                if(this.model.grupFrom.img != null){
                    src =  "data:image/png;base64,"+this.model.grupFrom.img;
                }
            }else if(this.model.userFrom != null){

                if(this.model.userFrom.img != null){
                    src =  "data:image/png;base64,"+this.model.userFrom.img;
                }

            }

            if(src == ""){
                src = "/img/defould.png";
            }

            _img.attr('src', src);

            var cw = _img.width();
            _img.css({'height':cw+'px'});



        },

        putOnClickOptions : function(view){

            var self = this;
            var options = this.$el.find('.options:last');

            var share = options.find('.option').eq(1).find('a:last');
            var viewFeedBack = options.find('.option').eq(0).find('a:last');
            var respon = options.find('.option').eq(2).find('a:last');
            var like = options.find('.option').eq(3).find('a:last');

            share.click(function(){
                self.compartir(view);
            });

            viewFeedBack.click(function(){
                self.$el.find('.commentary').each(function(index){
                    $(this).css("display", "");
                });
            });

            respon.click(function(){
               self.doResponse();

            });

            like.click(function(){

                self.like(view);

            });

            like.hover(function(){

                if(self.model.like != null && self.model.like){
                    $(this).find('span:last').removeClass('glyphicon-thumbs-up');
                    $(this).find('span:last').addClass('glyphicon-thumbs-down');
                }else{
                    $(this).find('span:last').addClass('blue-color');
                }
            },function(){

                if(self.model.like != null && self.model.like){
                    $(this).find('span:last').removeClass('glyphicon-thumbs-down');
                    $(this).find('span:last').addClass('glyphicon-thumbs-up');
                }else{
                    $(this).find('span:last').removeClass('blue-color');
                }
            });
        },


        like : function(view){
            var self = this;
            var like = true;

            if(this.model.like != null && this.model.like){
                like = false;
            }else{
                like = true;
            }

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/like",
                type : "PUT",
                dataType : "json",
                data : {
                    postId : self.model.id,
                    //commentaryId : self.model.id,
                    like : like
                }
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    self.model = response;

                    self.render(view);

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;Actualitzat.</div>');
                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;Error en la actualització.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();

                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;Error en la actualització.</div>');

            });



        },

        doResponse : function(){

            var self = this;

            if(self.$el.find('textarea').length > 0){ return;}

            self.$el.append('<div class="">' +
                '<div class="col-md-8 col-md-offset-2 inTheLine"> <strong>Respondre com:&nbsp;</strong>' +
                '<select>' +
                '<option>Jo</option>' +
                '</select>' +
                '</div>' +
                '<div class="col-md-8 col-md-offset-2">' +
                '<textarea class="sizeTextArea" maxlength="140"></textarea>' +
                '</div>' +
                '<div class="col-md-2"><button class="btn btn-primary btn-sm">Enviar</button></div>' +
                '</div>');


            var _select = self.$el.find('div:last').parent().find('select:last');
            self.optionsFrom(_select);

            //var textarea = self.$el.find('div:last').find('textarea:last');
            var textarea = self.$el.find('textarea:last');
            textarea.focus();

            //var btn = self.$el.find('div:last').find('button:last');
            var btn = textarea.parent().parent().find('button:last');

            textarea.keypress(function(event){
                var keycode = (event.keyCode ? event.keyCode : event.which);
                if(keycode == '13'){
                    self.addComent(textarea);
                }
            });

            btn.click(function(){self.addComent(textarea);});

        },

        addComent : function(textarea){

            if(textarea.val() == null || textarea.val() == ""){return null;}
            var self = this;

            var _select = textarea.parent().parent().find('select:last');

            var userId = -1;
            var grupId = -1;

            if(_select.val() == "Jo"){
                userId = self.model.idcurrent;
            }else{
                grupId = _select.val();
            }

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/commentary",
                type : "POST",
                dataType : "json",
                data : {
                    postId : self.model.id,
                    text : textarea.val(),
                    userId : userId,
                    grupId : grupId
                }
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    self.printCommentary(textarea.parent().parent(),response,true);

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;s\'ha publicat amb èxit.</div>');
                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;Error en la publicació del comentari.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();

                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;Error en la publicació del comentari.</div>');

            });

        },

        printListCommentary : function(list){

            if (list == null){return null;}

            for(var i in list){
                this.$el.append('<div></div>');
                var _div = this.$el.find('div:last');
                this.printCommentary(_div,list[i],false);
            }
        },

        printCommentary : function(_div,commentary,show){

            var c = new vCommentary({el:_div,model:commentary});
            c.render(show,this);
        },

        optionsFrom : function(_select){
            var self = this;

            var json = $.ajax({
                url : "/rest/user/infoLite",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){

                    if(response.grups == null || response.grups.length == 0){
                    }else{

                        if(response.grups.length > 0){
                            for(var i in response.grups){

                                var id = response.grups[i].id;
                                var name = response.grups[i].name;

                                _select.append('<option value="'+id+'">'+name+'</option>');
                            }
                        }
                    }
                }

            }).fail(function( response ) {
                vartime.quit();

            });
        },

        check : function(text){

            if(text.indexOf("youtube") >= 0){

                var strings = text.split("youtube");

                var url = "";
                if(text.indexOf("youtube") == 0){
                    var url = strings[0].split(" ")[0];
                }else{
                    var url = strings[1].split(" ")[0];
                }

                var code = url.split("v=")[1];

                return code;
            }

            return "";
        },

        checkSoundCloud : function(text){

            if(text.indexOf("soundcloud.com") >= 0){

                var strings = text.split("soundcloud.com");

                var url = "";
                if(text.indexOf("youtube") == 0){
                    var url = strings[0].split(" ")[0];
                }else{
                    var url = strings[1].split(" ")[0];
                }

                return "https://soundcloud.com"+url;
            }

            return "";



        },

        getIframeSoundCloud : function(track_url,_div){

            SC.initialize({
                     client_id: "0fa867c152948e85740c2448210510e7"
                    });

            //var track_url = "https://soundcloud.com/greenday/12-the-forgotten";
               SC.oEmbed(track_url, {auto_play: false,
                   show_comments: false,
                   sharing : false,
                   show_artwork: true,
                   maxheight: 200}, function(oEmbed) {
                   _div.prepend(oEmbed.html)
                 });
        }

    });


    return vPost;
});



