/**
 * Created by marc on 31/03/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/post/tTextPost.html',
    'views/post/vPost',
    'models/mPublicaciones',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,tTextPost,vPost,mPublicaciones,vVarTime){

    var vTextBox = Backbone.View.extend({

        events: {
        },

        initialize : function(){
            this.$el.html("");
        },

        render: function(friends){
            this.$el.html("");
            this.update(friends);
        },

        update : function(friends){

            this.getPost(-1,friends);
        },

        printListPost : function(listPost,friends){

           var self = this;
           var overflow = false;

            self.$el.find('.post').each(function(index){

               $(this).show();
               overflow = true;
           });


           var MAX_POST = 10;
            for(var i in listPost){

                if(i > MAX_POST || overflow){
                    overflow = true;
                    this.PrintPostHide(listPost[i]);
                }else{
                    this.PrintPost(listPost[i]);
                }
            }

            if(overflow){
                this.$el.append('<div class="footer ">' +
                    '<div class="col-md-12 center margin-top-1em"><a>Veure més</a></div>' +
                    '</div>');

                var footer = this.$el.find('.footer:last').find('div:last').find('a:last');

                footer.click(function(){

                    var nPost = 0;
                    self.$el.find('.post').each(function(index){
                        //$(this).show();
                        nPost = index;
                    });

                    $(this).parent().parent().remove();

                    var lastPost = listPost[listPost.length -1].id;
                    self.getPost(lastPost,friends);

                });
            }

        },

        PrintPost : function(p){
            this.$el.append('<div></div>');
            var _divPost = this.$el.find('div:last');
            var post = new vPost({ el : _divPost, model :  p});
            post.render(this);
        },

        PrintPostHide : function(p){
            this.$el.append('<div></div>');
            var _divPost = this.$el.find('div:last');
            var post = new vPost({ el : _divPost, model :  p});
            post.render(this);
            _divPost.hide();
        },

        PrintFirstPost : function(p){
            this.$el.prepend('<div></div>');
            var _divPost = this.$el.find('div:first');
            var post = new vPost({ el : _divPost, model :  p});
            post.render(this);
        },

        setEl : function(el){
            this.$el = el;
        },

        getPost : function(last,friends){

            var self = this;
            var url = "";

            if(friends){
                url = "/rest/post/friends/"+this.model.id
            }else if(this.model.is == "USER"){
                url = "/rest/post/user/"+this.model.id
            }else if(self.model.is == "GRUP"){
                url = "/rest/post/group/"+this.model.id;
            }else{

            }

            if(last != null && url != ""){
                url += "/" + last;
            }else{
                url += "/";
            }

            var vartime = new vVarTime();
            vartime.render();

            var json = $.ajax({
                url : url,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    self.printListPost(response.list,friends);
                }

            }).fail(function( response ) {
                vartime.quit();

            })

        }

    });


    return vTextBox;
});

