/**
 * Created by marc on 06/05/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/post/tTextBoxPost.html',
    'views/vMsg',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,tTextBoxPost,vMsg,vVarTime){

    var view = Backbone.View.extend({


        initialize : function(){

        },

        render: function(_divPublicacions){

            this.$el.html("");
            var self = this;
            var touch = false;
            this.$el.append( _.template( tTextBoxPost, {}));

            var textarea = this.$el.find('textarea:last');
            var carc = this.$el.find('small:last');carc.parent().hide();
            var btn = this.$el.find('button:last');btn.parent().hide();
            var btnSong = this.$el.find('button').eq(0);btnSong.parent().hide();
            var selectFrom = this.$el.find('select').eq(0);selectFrom.parent().hide();
            var text = "";

            this.optionsFrom(selectFrom);

            textarea.focus(function(){
                $(this).addClass('sizeFocus');

                carc.parent().show();
                btn.parent().show();
                btnSong.parent().show();

                if(selectFrom.children('option').size() > 1){
                    selectFrom.parent().show();
                }

            });

            textarea.blur(function(){
                if(text.length == 0 ){
                    $(this).removeClass('sizeFocus');
                    carc.parent().hide();
                    btn.parent().hide();
                    btnSong.parent().hide();
                    selectFrom.parent().hide();
                }
            });

            var timeoutId = 0;
            textarea.keypress(function(){
                clearTimeout(timeoutId);
                timeoutId = setTimeout(function(){
                    text = textarea.val();

                    var nCarc = text.length;
                    carc.html(nCarc+"/140");

                    if(nCarc > 0 && nCarc <= 140){

                        carc.removeClass('color-error');
                        carc.removeClass('color-danger');

                        if( nCarc > 130){
                            carc.removeClass('color-error');
                            carc.addClass('color-danger');
                        }

                        btn.addClass('btnOK');
                    }else{
                        carc.removeClass('color-error');
                        carc.removeClass('color-danger');

                        if(nCarc > 140){
                            carc.addClass('color-error');
                            carc.removeClass('color-danger');
                        }

                        btn.removeClass('btnOK');
                    }
                }, 100);

            });

            this.$el.find('.optionTextBox').eq(0).click(function(){

                self.inputUrl(null);

            });


            btn.click(function(){
                if(textarea.val().length > 0 && textarea.val().length <= 140){

                    self.check(textarea);

                    var data = {};
                    text = textarea.val();
                    var userToId = null;
                    var grupToId = null;
                    var userFromId = null;
                    var groupFromId = null;
                    var postShareId = null;
                    var url = "";

                    if(self.model.is == "USER"){
                        userToId = self.model.id;

                        if(selectFrom.val() == -1){
                            userFromId = self.model.idcurrent;

                            data = {
                                "text" : text,
                                "userToId" : userToId,
                                "userFromId" : userFromId
                            }

                        }else{
                            groupFromId = selectFrom.val();

                            data = {
                                "text" : text,
                                "userToId" : userToId,
                                "groupFromId" : groupFromId
                            }
                        }

                    }else if(self.model.is == "GRUP"){
                        grupToId = self.model.id;

                        if(selectFrom.val() == -1){
                            userFromId = self.model.idcurrent;

                            data = {
                                "text" : text,
                                "grupToId" : grupToId,
                                "userFromId" : userFromId
                            }

                        }else{
                            groupFromId = selectFrom.val();

                            data = {
                                "text" : text,
                                "grupToId" : grupToId,
                                "groupFromId" : groupFromId
                            }
                        }
                    }else{

                        if(selectFrom.val() == -1){
                            userFromId = self.model.idcurrent;

                            data = {
                                "text" : text,
                                "userFromId" : userFromId
                            }

                        }else{
                            groupFromId = selectFrom.val();

                            data = {
                                "text" : text,
                                "groupFromId" : groupFromId
                            }
                        }
                    }

                    var vartime = new vVarTime();
                    vartime.render();

                    var json = $.ajax({
                        url : "/rest/post",
                        type : "POST",
                        dataType : "json",
                        data: data
                    }).done(function( response, status, jqXHR ) {
                        if(response.state == "OK"){
                            vartime.quit();

                            if(_divPublicacions != null){

                                var msg = new vMsg();

                                self.render(_divPublicacions);

                               /* textarea.val("");
                                textarea.removeClass('sizeFocus');
                                carc.html("0/140");
                                carc.removeClass('color-error');
                                carc.removeClass('color-danger');
                                carc.parent().hide();
                                btn.parent().hide();
                                btnSong.parent().hide();
                                selectFrom.parent().hide();
                                */

                                _divPublicacions.PrintFirstPost(response);

                                msg.render('<div class="green-color">' +
                                    '<span class="glyphicon glyphicon-ok"></span>' +
                                    '&nbsp;La publicació s\'ha publicat amb èxit. </div>');


                            }

                        }else{
                            var msg = new vMsg();
                            msg.render('<div class="color-error">' +
                                '<span class="glyphicon glyphicon-remove"></span>' +
                                '&nbsp;Error en la publicació.</div>');
                        }

                    }).fail(function( response ) {
                        vartime.quit();
                        var msg = new vMsg();
                        msg.render('<div class="color-error">' +
                            '<span class="glyphicon glyphicon-remove"></span>' +
                            '&nbsp;Error en la publicació.</div>');

                    });


                }else{
                    btn.removeClass('btnOK');
                }

            });

        },


        optionsFrom : function(_select){
            var self = this;

            var json = $.ajax({
                url : "/rest/user/infoLite",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                    if(response.state == "OK"){

                        if(response.grups == null || response.grups.length == 0){
                        }else{

                            if(response.grups.length > 0){
                                for(var i in response.grups){

                                    var id = response.grups[i].id;
                                    var name = response.grups[i].name;

                                    _select.append('<option value="'+id+'">'+name+'</option>');
                                }
                            }
                        }
                    }

            }).fail(function( response ) {

            });
        },

        inputUrl : function(url){

            if(url == null){
                this.$el.append('<div class="col-md-12"><input  class="Iteminput" type="text" placeholder="url" name="url"></div>');

            }else{
                this.$el.append('<div class="col-md-12"><input  class="Iteminput" type="text" placeholder="url" value="'+url+'" name="url"></div>');
            }
        },


        isMember : function(id){

            for(var i in this.model.users){
                var u = this.model.users[i];
                if(id == u.id){return true;}


            }

            return false;
        },


        check : function(textarea){

            var text = textarea.val();

            if(text.indexOf("youtube") >= 0){

                var strings = text.split("youtube");

                var url = "";
                if(text.indexOf("youtube") == 0){
                    var url = strings[0].split(" ")[0];
                }else{
                    var url = strings[1].split(" ")[0];
                }

                var code = url.split("v=")[1];

                return code;
            }

            return "";
        }

    });

    return view;

});

