/**
 * Created by marc on 28/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/search/tItemSearch.html'
], function($, _, Backbone,Bootstrap,tItemSearch){

    var vPost = Backbone.View.extend({

        events: {
        },

        initialize : function(){
            this.$el.html("");
            this.render();
        },

        render: function(){

            var self = this;

            if(this.model.is == "GRUP"){
                var options = "";
                var friend = true;

                if(this.model.relation == "FRIEND"){
                    options += '<a class="option">Deixar de seguir</a>';
                }else if(this.model.relation == "NO_FRIEND"){
                    friend = false;
                    options += '<a class="option">Seguir</a>'
                }

                if(this.model.relation != "OWN"){

                    var txt = ' amics seguint a ';

                    if((this.model.commonFriends == null ? 0 : this.model.commonFriends) == 1){
                        txt = ' amic seguint a ';
                    }

                    options += '<a class="option">'+
                        (this.model.commonFriends == null ? 0 : this.model.commonFriends) +
                        txt + this.model.name+'</a>';
                }

                this.$el.addClass('post');

                var _name = this.model.name;
                var _text = this.rederText(this.model.description);

                var compiledTemplate = _.template( tItemSearch,
                    {nameuser : _name,
                        description : _text,
                        options : options} );

                this.$el.append( compiledTemplate );

                if(this.model.relation == "FRIEND"){

                    this.$el.find(".option:eq(0)").click(function(){

                        self.unfriend(self.model.id,self.$el.find(".option:eq(0)"));
                    });

                }else if(this.model.relation == "NO_FRIEND"){
                    this.$el.find(".option:eq(0)").click(function(){

                        self.friend(self.model.id,self.$el.find(".option:eq(0)"));
                    });
                }

                var src = "";
                var _img = this.$el.find('img:last');

                if(this.model.imguser != null){

                    src =  "data:image/png;base64,"+this.model.imguser;

                }else{
                    if(src == ""){
                        src = "/img/defould.png";
                    }
                }
                _img.attr('src', src);


                var href = "";
                if(this.model.id != null){
                    href =  "/#group/"+this.model.id;
                }else{
                    href=''
                }
                var _a = this.$el.find('a:first');
                _a.attr('href', href);


            }


        },

        rederText : function(pText){

            if(pText == null || pText == ""){
                return "";
            }
            var MAXLENGTH = 65;

            var text = "";
            var mySplitResult = pText.split(" ");
            for(x = 0; x < mySplitResult.length; x++){

                if (mySplitResult[x].length > MAXLENGTH) {
                    while(mySplitResult[x].length > MAXLENGTH){
                        var aux = mySplitResult[x].substring(0,MAXLENGTH);
                        mySplitResult[x] = mySplitResult[x].substring(MAXLENGTH+1,mySplitResult[x].length);
                        text += aux + " ";
                    }
                }else{
                    text += mySplitResult[x] + " ";
                }
            }
            return text;
        },

        setEl : function(el){
            this.$el = el;
        },

        borrar : function(){

            if(confirm('Seguro que quiere eliminar la publicacion?')){

                var self = this;
                var json = $.ajax({
                    url : "/rest/post/my/"+self.model.id,
                    type : "DELETE",
                    dataType : "json"
                }).done(function( response, status, jqXHR ) {
                    if(response.state == "OK"){
                        self.$el.hide();
                    }

                }).fail(function( response ) {

                });
            }
        },

        friend : function(id,_btn){

            var self = this;

            var friendsJNSON = $.ajax({
                url : "rest/friend",
                type : "POST",
                dataType : "json",
                data : {
                    id : id
                }
            }).done(function( item, status, jqXHR ){

                if(item.state == "OK"){
                    _btn.html('Deixar de seguir');
                    _btn.click(function(){
                        self.unfriend(id,_btn);
                    });

                }
            }).fail(function(response){

            });
        },

        unfriend : function(id,_btn){

            var self = this;

            var friendsJNSON = $.ajax({
                url : "rest/friend/update",
                type : "PUT",
                dataType : "json",
                data : {
                    id : id,
                    friend : false
                }
            }).done(function(item, status, jqXHR){

                if(item.state == "OK"){
                    _btn.html('seguir');
                    _btn.click(function(){
                        self.friend(id,_btn);
                    });
                }
            }).fail(function(response){

            });
        }

    });


    return vPost;
});

