/**
 * Created by marc on 22/04/14.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/utils/tAutocompleteUser.html'
], function($, _, Backbone,Bootstrap,tAutocomplete){

    var AutocompleteUsers = Backbone.View.extend({

        initialize : function(){
            this.$el.html("");
        },

        render: function(_input){

            var self = this;
            //append Template
            this.$el.append( _.template( tAutocomplete, {} ) );
            var _divUsers = self.$el.find('div:first').find('div:first');
            _divUsers.hide();

            var timeoutId = 0;
            _input.keypress(function () {
                clearTimeout(timeoutId);
                timeoutId = setTimeout(function(){

                    var txt = _input.val();


                    if(txt.length > 2){


                        var json = $.ajax({
                            url : "/rest/search/friends/"+txt,
                            type : "GET",
                            dataType : "json"
                        }).done(function( response, status, jqXHR ) {

                            if(response.state == "OK"){
                                _divUsers.show();

                                self.printList(response.list,_input);
                            }
                        }).fail(function( response ) {

                        });

                    }else{
                        _divUsers.html("");
                        _divUsers.hide();
                    }


                }, 800);
            });

        },

        printList : function(list,_input){

            var self = this;
            var _divUsers = this.$el.find('div:first').find('div:first');
            var _ulUsersAssig = this.$el.find('.assigBoxnItem:last').find('.luItem:last');

            _divUsers.html("");

            if(list != null){
                for(var i = 0;i < list.length; i++){

                    var item = list[i];

                    self.printItem(_divUsers, item,_input);

                }
            }

        },

        getModel : function(){
            return this.model;
        },

        printItem : function(_divUsers,item,_input){
            var self = this;
            var u = '<div class="itemAutocomplete">' +
                item.name + ' ' + item.secondname +
                '</div>';
            _divUsers.append(u);
            _divUsers.find('div:last').dblclick(function(){

                var id = item.id;
                var name = item.name + ' ' + item.secondname;
                self.model = item;

                _input.val(name);
                _divUsers.html("");
                _divUsers.hide();


            });
        }

    });

    return AutocompleteUsers;

});
