/**
 * Created by marc on 22/04/14.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../../templates/utils/tAutocomplete.html'
], function($, _, Backbone,Bootstrap,tAutocomplete){

    var AutocompleteUsers = Backbone.View.extend({

        initialize : function(){
            this.$el.html("");
            this.render();
        },

        render: function(){

            var self = this;
            //append Template
            this.$el.append( _.template( tAutocomplete, {} ) );

            var box = this.$el.find('.ItemBoxAutocomplete').eq(0);
            box.hide();

            var boxAssing = this.$el.find('.assigBoxnItem').eq(0);
            boxAssing.hide();


            var timeoutId = 0;
            this.$el.find('div:first').find('input:first').keypress(function () {
                clearTimeout(timeoutId);
                timeoutId = setTimeout(self.autocomplete(), 1500);
            });

        },

        autocomplete : function(){

            var box = this.$el.find('.ItemBoxAutocomplete').eq(0);
            var txt = this.$el.find('div:first').find('input:first').val();
            var _divUsers = this.$el.find('div:first').find('div:first');

            var self = this;
            if(txt.length > 2){

                var json = $.ajax({
                    url : "/rest/search/friends/"+txt,
                    type : "GET",
                    dataType : "json"
                }).done(function( response, status, jqXHR ) {

                    if(response.state == "OK"){

                        self.printList(response.list);
                    }
                }).fail(function( response ) {

                });

            }else{
                _divUsers.html("");
                box.hide();
            }


        },

        printList : function(list){

            var box = this.$el.find('.ItemBoxAutocomplete').eq(0);
            var self = this;
            var _divUsers = this.$el.find('div:first').find('div:first');
            var _ulUsersAssig = this.$el.find('.assigBoxnItem:last').find('.luItem:last');

            _divUsers.html("");

            if(list != null){

                if(list.length == 0){
                    box.hide();

                }else{
                    box.show();

                }

                for(var i = 0;i < list.length; i++){

                    var item = list[i];

                    self.printItem(_divUsers,_ulUsersAssig, item);

                }
            }else{box.hide();}

        },

        printItem : function(_divUsers,_ulUsersAssig,item){
            var self = this;
            var span = '<span class="glyphicon glyphicon-arrow-right colorspan"></span>';

            var u = '<div class="itemAutocomplete">' +
                item.name + ' ' + item.secondname + '  ' + span +
                '</div>';
            _divUsers.append(u);
            _divUsers.find('div:last').find('span:last').click(function(){

                var id = item.id;
                var name = item.name + ' ' + item.secondname;

                var exist = false;
                _ulUsersAssig.find('li').each(function(index){
                    if($(this).val() == id){
                        exist = true;
                    }
                });

                if(!exist){
                    self.printUserAssing(item,_ulUsersAssig, id, name);
                }


            });
        },

        printUserAssing : function(item, _ulUsersAssig, id, name){

            var boxAssing = this.$el.find('.assigBoxnItem').eq(0);
            var boxAssing = this.$el.find('.assigBoxnItem').eq(0);
            boxAssing.show();

            var spanDelete = '<span class="glyphicon glyphicon-remove colorspanDelete"></span>';


            _ulUsersAssig.append('<li class="liItem" value="'+ item.id +'">' +
                name +
                '  ' + spanDelete +
                '</li>');

            var _li = _ulUsersAssig.find('li:last');

            _ulUsersAssig.find('li:last').find('span:last').click(function(){

                _li.remove();

                if(_ulUsersAssig.find('li').length > 0){
                    boxAssing.show();
                }else{
                    boxAssing.hide();

                }
            });

        },

        getArray : function(){

            var array = new Array();

            var _ulUsersAssig = this.$el.find('.assigBoxnItem:last').find('.luItem:last');

            var i = 0;
            _ulUsersAssig.find('li').each(function(index){
                array[i] = $(this).val();
            });

            return array;
        }
    });

    return AutocompleteUsers;

});
