/**
 * Created by marc on 08/04/14.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../templates/edit/tEdit.html',
    'text!../../templates/edit/tFormDP.html',
    'text!../../templates/edit/tFormAdress.html',
    'text!../../templates/edit/tUsuariDetails.html',
    'views/edit/vAdminGrup',
    'views/vMsg',
    'views/utils/vVarTime',
    'text!../../modal/modalTermsAndConditions.html'
], function($, _, Backbone,Bootstrap,tEdit,tFormDP,tFormAdress,tUsuariDetails,vAdminGrup,vMsg,vVarTime,modalTermsAndConditions){

    var vEditInfo = Backbone.View.extend({

        el: $('#contextApp'),

        events: {
            "click #IdtermsAndConditions": "showconditions"

        },

        defaults :{
        },

        initialize : function(){
            this.$el.html("");
        },

        render: function(){

            this.$el.append(_.template(tEdit, {}));

            var _divPrincipal = this.$el.find('#idDivEditInformation');

            var self = this;

            var json = $.ajax({
                url : "/rest/infouser/my",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                var idioma = "cat";

                _divPrincipal.append('<div class="col-md-12 borderBottom"></div>');
                var _divItem0 = _divPrincipal.find('div:last');
                _divItem0.append('<div class="col-md-5">Descripció i foto principal</div><div class="col-md-1 col-md-offset-4">' +
                    '<button class="text_small btnEditar">modificar</button></div>');
                _divItem0.append('<div class="wrapInfoUser">'+ _.template(tUsuariDetails, {})+'</div>');

                _divItem0.find('div:eq(2)').hide();

                _divItem0.find('div:eq(1)').find('button:last').click(function(){
                    _divItem0.find('div:eq(2)').show();
                });

                _divItem0.find('#idInfoGeneralTextAreaDescription').val(response.user.description);

                _divItem0.find('div:eq(2)').find('.saveOK').hide();
                _divItem0.find('div:eq(2)').find('.saveERROR').hide();

                _divItem0.find('div:eq(2)').find('button:last').click(function(){
                    self.updateDescripionAndFoto(_divItem0);
                });

                $("#uploadedfile").on("change", function(){
                    var file = this.files[0],
                        fileName = file.name,
                        fileSize = file.size;

                    var reader = new FileReader();

                    reader.onload = function (e) {
                        $('#imguploadedfile')
                            .attr('src', e.target.result)
                            .width(100)
                            .height(100);
                    };

                    reader.readAsDataURL(file);

                    //alert("Uploading: "+fileName+" @ "+fileSize+"bytes");
                    //CustomFileHandlingFunction(file);
                });

                //DADES PERSONALS

                _divPrincipal.append('<div class="col-md-12 margin-top-1em borderBottom"></div>');
                var _divItem1 = _divPrincipal.find('div:last');
                _divItem1.append('<div class="col-md-3">Dades personals</div><div class="col-md-1 col-md-offset-6">' +
                    '<button class="text_small btnEditar">modificar</button></div>');

                _divItem1.append('<div class="wrapInfoUser">'+ _.template(tFormDP, {})+'</div>');

                $('#idInfoGeneralinputDate').datetimepicker({
                    lang:'cat',
                    timepicker:false,
                    format:'d/m/Y'});

                _divItem1.find('div:eq(2)').hide();

                var selct = _divItem1.find('#idInfoGeneralselectSex');
                _divItem1.find('#idInfoGeneralinputName').val(response.user.name);
                _divItem1.find('#idInfoGeneralinputSecond').val(response.user.secondname);
                _divItem1.find('#idInfoGeneralinputDate').val(response.birthday);

                if(response.sex == "MALE"){
                    selct.prepend('<option value="MALE" selected>Home</option>');
                }else if(response.sex == "FEMALE"){
                    selct.prepend('<option value="FEMALE" selected>Dona</option>');
                }

                self.putSelectPrivacity(_divItem1,response.birthdayPrivacity, "idInfoGeneralselectDatePrivacity");
                self.putSelectPrivacity(_divItem1,response.sexPrivacity, "idInfoGeneralselectSexPrivacity");

                _divItem1.find('div:eq(1)').find('button:last').click(function(){
                    _divItem1.find('div:eq(2)').show();
                });

                _divItem1.find('div:eq(2)').find('.saveOK').hide();
                _divItem1.find('div:eq(2)').find('.saveERROR').hide();

                _divItem1.find('div:eq(2)').find('button:last').click(function(){
                    self.datosPersonales(_divItem1);
                });


                //ADREça

                _divPrincipal.append('<div class="col-md-12 margin-top-1em borderBottom"></div>');
                var _divItem2 = _divPrincipal.find('div:last');
                _divItem2.append('<div class="col-md-3">Adreça</div><div class="col-md-1 col-md-offset-6">' +
                    '<button class="text_small btnEditar">modificar</button></div>');

                _divItem2.append('<div class="wrapInfoUser">'+ _.template(tFormAdress, {})+'</div>');
                _divItem2.find('div:eq(2)').hide();

                _divItem2.find('#idInfoGeneralinputCity').val(response.city);
                _divItem2.find('#idInfoGeneralinputCountry').val(response.country);
                self.putSelectPrivacity(_divItem2,response.cityPrivacity, "idInfoGeneralselectCityPrivacity");
                self.putSelectPrivacity(_divItem2,response.countryPrivacity, "idInfoGeneralselectCountryPrivacity");
                _divItem2.find('div:eq(2)').find('.saveOK').hide();
                _divItem2.find('div:eq(2)').find('.saveERROR').hide();

                _divItem2.find('div:eq(1)').find('button:last').click(function(){
                    _divItem2.find('div:eq(2)').show();
                });

                _divItem2.find('div:eq(2)').find('button:last').click(function(){
                    self.saveAdress(_divItem2);
                });

                //Crear Grup

                _divPrincipal.append('<div class="col-md-12 margin-top-1em borderBottom"></div>');
                var _divItem3 = _divPrincipal.find('div:last');
                _divItem3.append('<div class="col-md-3">Grup</div><div class="col-md-1 col-md-offset-6">' +
                    '<button class="text_small btnEditar">modificar</button></div>');

                _divItem3.append('<div class="wrapInfoUser"></div>');
                var _divAdminGrup = _divItem3.find('div:eq(2)');
                _divAdminGrup.hide();

                _divItem3.find('div:eq(1)').find('button:last').click(function(){
                    _divAdminGrup.show();
                });

                var adminGrup = new vAdminGrup({ el : _divAdminGrup});
                adminGrup.render();

            }).fail(function( response ) {

            });


        },

        datosPersonales : function(_divItem1){

            var vartime = new vVarTime();
            vartime.render();
            vartime.quit();
            var json = $.ajax({
                url : "/rest/infouser/my/persoanl",
                type : "PUT",
                dataType : "json",
                data : {
                    name: _divItem1.find('div:eq(2)').find('#idInfoGeneralinputName').val(),
                    secondname: _divItem1.find('div:eq(2)').find('#idInfoGeneralinputSecond').val(),
                    birthday: _divItem1.find('div:eq(2)').find('#idInfoGeneralinputDate').val(),
                    birthdayPrivacity: _divItem1.find('div:eq(2)').find('#idInfoGeneralselectDatePrivacity option:selected').val(),
                    Person: _divItem1.find('div:eq(2)').find('#idInfoGeneralselectSex option:selected').val(),
                    SexPrivacity: _divItem1.find('div:eq(2)').find('#idInfoGeneralselectSexPrivacity option:selected').val()

                }
            }).done(function( response, status, jqXHR ) {

                vartime.quit();
                if(response.state == "OK"){
                    _divItem1.find('div:eq(2)').find('.saveOK').show();

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;Informació Editada.</div>');

                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;s\'ha produit un error.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();
                _divItem1.find('div:eq(2)').find('.saveERROR').show();
                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;s\'ha produit un error.</div>');

            });

        },

        putSelectPrivacity : function(_divItem1,item,div){

            if(item == "PUBLIC"){
                _divItem1.find('#'+div).prepend('<option value="PUBLIC" selected>Public</option>');
            }else if(item == "PRIVATE"){
                _divItem1.find('#'+div).prepend('<option value="PRIVATE" selected>Privat</option>');
            }else if(item == "FRIENDS"){
                _divItem1.find('#'+div).prepend('<option value="FRIENDS" selected>Amics</option>');
            }
        },
        showconditions : function(){

            $('#modalApp').html("");
            $('#modalApp').append(_.template( modalTermsAndConditions,{}) );
            $('#modalApp').modal('show');

        },

        saveAdress : function(_div){

            var vartime = new vVarTime();
            vartime.render();

            var json = $.ajax({
                url : "/rest/infouser/my/persoanl",
                type : "PUT",
                dataType : "json",
                data : {
                    city: _div.find('div:eq(2)').find('#idInfoGeneralinputCity').val(),
                    cityPrivacity: _div.find('div:eq(2)').find('#idInfoGeneralselectCityPrivacity option:selected').val(),
                    country: _div.find('div:eq(2)').find('#idInfoGeneralinputCountry').val(),
                    countryPrivacity: _div.find('div:eq(2)').find('#idInfoGeneralselectCountryPrivacity option:selected').val()

                }
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    _div.find('div:eq(2)').find('.saveOK').show();

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;Informació Editada.</div>');

                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;s\'ha produit un error.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();
                _div.find('div:eq(2)').find('.saveERROR').show();
                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;s\'ha produit un error.</div>');

            });

        },

        updateDescripionAndFoto : function(_div){

            var srcPhoto = $("#imguploadedfile").attr('src');

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/infouser/my/persoanl",
                type : "PUT",
                dataType : "json",
                data : {
                    description: _div.find('div:eq(2)').find('#idInfoGeneralTextAreaDescription').val(),
                    photo: srcPhoto

                }
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    _div.find('div:eq(2)').find('.saveOK').show();

                    var msg = new vMsg();
                    msg.render('<div class="green-color">' +
                        '<span class="glyphicon glyphicon-ok"></span>' +
                        '&nbsp;Informació Editada.</div>');

                }else{

                    var msg = new vMsg();
                    msg.render('<div class="color-error">' +
                        '<span class="glyphicon glyphicon-remove"></span>' +
                        '&nbsp;s\'ha produit un error.</div>');
                }

            }).fail(function( response ) {
                vartime.quit();
                _div.find('div:eq(2)').find('.saveERROR').show();
                var msg = new vMsg();
                msg.render('<div class="color-error">' +
                    '<span class="glyphicon glyphicon-remove"></span>' +
                    '&nbsp;s\'ha produit un error.</div>');

            });

        }

    });





    return vEditInfo;

});