/**
 * Created by marc on 22/04/14.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/vVar',
    'text!../../templates/grup/tGrup.html',
    'views/grup/vFactoryButtons',
    'views/grup/vComingEvens',
    'views/grup/vSCList',
    'views/post/vTextBoxPost',
    'views/post/vPublicaciones',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,vVar,tGrup,vFactoryButtons,vComingEvens,vSCList,vTextBoxPost,vPublicaciones,vVarTime){

    var vGrup = Backbone.View.extend({

        el: $('#contextApp'),

        initialize : function(){
            this.$el.html("");
            try{
                $('#modalApp').modal('hide');
            }catch (err){}
            //this.render();
        },

        render: function(id){
            this.$el.html("");

            if(id == null){return;}

            var vvar = new vVar();
            vvar.render();

            this.init(id);
        },

        init : function(id){
            if(id == null){return;}

            var self = this;

            var vartime = new vVarTime();
            vartime.render();

            var json = $.ajax({
                url : "/rest/grup/"+id,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    //append Template

                    self.$el.append( _.template( tGrup, {
                        name : response.name,
                        description : response.description
                    }));

                    var btn = new vFactoryButtons({
                        el : self.$el.find('#idDivGrupButtons'),
                        model : response});
                    btn.render(self);


                    self.printMember(response.users);

                    var _publicaciones = new vPublicaciones({
                        el : $("#idDivGrupPrincipalPublicaciones"),
                        model: response});

                    _publicaciones.render();

                    if(response.follow){
                        var textBoxPost = new vTextBoxPost({el: $('#IdDivPublicacionsTextBoxGrups'),
                            model : response});
                        textBoxPost.render(_publicaciones);
                    }


                    var events = new vComingEvens({
                        el : self.$el.find('#idDivGrupEvents'),
                        model : response
                    });
                    events.render(self);

                    var _cançons = new vSCList({
                        el: self.$el.find('#idMenuRightGrup'),
                        model: response});

                }else{
                    window.location.href = "/#login";
                }
            }).fail(function( response ) {
                vartime.quit();

            });
        },

        printMember : function(members){

            var _div = this.$el.find('#idDivGrupMembers');

            for(var i in members){

                var member = members[i];

                if(member.status == "OK"){
                    var rolname = member.rol == null ? "" : member.rol;
                    var user = '<div class="col-md-12"><a href="/#profile/'+member.id+'">'+member.name+'</a></div>';
                    var rol = '<div class="col-md-12"><small>'+ rolname +'</small></div>';

                    _div.append( user + rol);
                }
            }


        }
    });

    return vGrup;

});
