define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'datetimepicker',
    'models/mLogin',
    'models/mRegistrar',
    'views/login/vVarLogin',
    'text!../../templates/login/tRegistrar.html',
    'text!../../templates/login/tBoxSocialSong.html',
    'text!../../modal/modalTermsAndConditions.html',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,datetimepicker,mLogin,mRegistrar,vVarLogin,registrarContext,tBoxSocialSong,
            modalTermsAndConditions,vVarTime){

    var View = Backbone.View.extend({

        el: $('#contextApp'),

        events: {
            "click #btnsubmitRegistrar": "registrar",
            "click #IdtermsAndConditions": "showconditions"
        },

        initialize : function(){
            $('#varApp').html("");
            this.init();
            this.render();

        },

        render: function(){

            $(this.el).html("");

            this.$el.append( _.template( tBoxSocialSong,{}) );
            this.$el.append( _.template( registrarContext,{}) );

            var VarLogin = new vVarLogin();

        },

        init : function(){
            var json = $.ajax({
                url : "/rest/auth/init",
                type : "POST",
                dataType : "json"

            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){
                    window.location.href = "/#my";
                }
            }).fail(function( response ) {
            });

        },

        showconditions : function(){

            $('#modalApp').html("");
            $('#modalApp').append(_.template( modalTermsAndConditions,{}) );
            $('#modalApp').modal('show');

        },


        registrar : function(){

            var name = $("#inputName_reg").val();
            var secondname = $("#inputSecondName_reg").val();
            var email = $("#inputEmail_reg").val();
            var pwd1 = $("#inputPassword_reg").val();
            var pwd2 = $("#inputPassword2_reg").val();
            var accept = this.$el.find('#inputAcceptConditions');

            var mregistrar = new mRegistrar();
            mregistrar.contruct(name,secondname,email,pwd1,pwd2);

            if(!mregistrar.check()){
                $("#msgError_reg").text("Emplanar tot els camps.");
                return;
            }else if(mregistrar.checkPaswords() != "OK"){
                $("#msgError_reg").text(mregistrar.checkPaswords());
                return;
            }

            var valueaccept =   accept.is(':checked');
            if(!valueaccept){
                $("#msgError_reg").text("Acceptar condicions d’ús i l’ús de galetes");
                return;
            }

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/auth/register",
                //contentType: 'application/json',
                type : "POST",
                dataType : "json",
                data : mregistrar.jsonData()
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                console.log('register successful', response);

                if(response.state == "OK"){
                    $("#msgError_reg").text("");
                    window.location.href = "/#my";
                }else{

                    $("#msgError_reg").text(response.message);
                }

            }).fail(function( response ) {
                vartime.quit();
                $("#msgError_reg").text("Error");
            });

        }

    });

    return View;

});