define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/vVar',
    'views/post/vTextBoxPost',
    'views/vNotifications',
    'text!../../templates/my/tMy.jsp',
    'views/post/vPublicaciones',
    'views/utils/vListHashtag'
], function($, _, Backbone,Bootstrap,vVar,vTextBoxPost,vNotifications,tMy,vPublicaciones,vListHashtag){

    var vMy = Backbone.View.extend({

        el: $('#contextApp'),

        initialize : function(){
            this.$el.html("");
            this.render();
        },

        render: function(){

            var vvar = new vVar();
                vvar.render();


            var compiledTemplate = _.template( tMy, {text_My_Publicaicones: "Publicaciones"} );
            this.$el.append( compiledTemplate );



            this.init();
        },

        init : function(){
            var json = $.ajax({
                url : "/rest/infouser/my",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){

                    var userName = response.user.name +" "+response.user.secondname;

                    var _publicaciones = new vPublicaciones({
                        el : $("#idDivMyPrincipalPublicaciones"),
                        model: response });

                    _publicaciones.render(true);

                    if(response.is != null){
                        response.is = "";
                    }

                    var textBoxPost = new vTextBoxPost({
                        el: $('#IdDivPublicacionsTextBoxMy'),
                        model : response});

                    textBoxPost.render(_publicaciones);

                    var _notificacions = new vNotifications({ el : $("#idDivMyNotifications")});

                }else{
                    //window.location.href = "/#login";
                }
            }).fail(function( response ) {

            });


            var json = $.ajax({
                url : "/rest/soundcloud/top4",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){

                    for(var i in response.list){

                        var song = response.list[i];

                        $('#IdTop4SC').append('<div class="col-md-3">'+song.iframe+'</div>');
                    }
                }

            }).fail(function( response ) {


            });


            var json = $.ajax({
                url : "/rest/hashtag/tendency",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){

                    if( response.list != null && response.list.length != 0){
                        var _ListHashtags = new vListHashtag({ el : $("#idTopTendency")});
                        _ListHashtags.render(response.list,"#Populars");
                    }
                }

            }).fail(function( response ) {


            });
        }
    });

    return vMy;

});