/**
 * Created by marc on 28/04/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'text!../../templates/notifications/tNotifications.html',
    'views/notifications/vItemNotifications',
    'text!../../../modal/modalDefould.html',
    'text!../../../modal/notifications/modalNotifications.html'
], function($, _, Backbone,Bootstrap,tNotifications,vItemNotifications,modalDefould,modalNotifications){

    var vNotifications = Backbone.View.extend({

        initialize : function(){
            this.$el.html("");
            this.render();
        },

        events: {
            "click #idNotificationsShowModal" : "showModal"
        },

        render: function(){

            this.$el.append( _.template( tNotifications, {} ) );
            $('#idNotificationsShowModal').hide();


            this.init();
        },

        init : function(){
            var self = this;
            var json = $.ajax({
                url : "/rest/notifications/my/0",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                self.model = response;
                if(response.state == "OK"){

                    if(response.list != null){

                        if(response.list != null && response.list.length > 3){
                            $('#idNotificationsShowModal').show();
                        }

                        self.printList(response.list,self.$el.find('div:first'),3);
                    }
                }

            }).fail(function(response) {

            });
        },

        printList : function(listPost,_div,max){

            _div.html("");

            for(var i in listPost){
                    _div.append('<div class="itemNotificationBox"></div>');
                    var _divPost = _div.find('div:last');
                    var post = new vItemNotifications({ el : _divPost, model :  listPost[i]});

                if( max != null && i > max){
                    _divPost.hide();
                }
            }

        },

        showModal : function(){

            var self = this;
            var bottom = '<ul class="pager">' +
                '<li id="idPagerModalNotificationsPrevius"><a id="idPagerModalNotificationsPreviusBtn">Anterior</a></li>' +
                '<li id="idPagerModalNotificationsNext"><a id="idPagerModalNotificationsNextBtn">Següent</a></li>' +
                '</ul>';

            $('#modalApp').html("");

            //init modal
            $('#modalApp').append(_.template(modalDefould, {}));
            $('#modalApp').find('.modal-title:first').html("Notificacions");
            $('#modalApp').find('.modal-body:first').html(_.template(modalNotifications, {}));
            $('#modalApp').find('.modal-footer:first').html(bottom);

            $('#idPagerModalNotificationsNextBtn').click(function(){
                self.NextPage();
            });

            $('#idPagerModalNotificationsPreviusBtn').click(function(){
                self.PreviusPage();
            });

            var json = $.ajax({
                url : "/rest/notifications/my/0",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                self.model = response;
                if(response.state == "OK"){

                    if(response.list != null){
                        self.printList(response.list,$('#modalApp').find('.modal-body:first').find('div:first'));

                        if(response.currentPage == (response.nPages-1)){
                            $('#idPagerModalNotificationsNext').hide()
                        }else{$('#idPagerModalNotificationsNext').show()}

                        if(response.currentPage > 0){
                            $('#idPagerModalNotificationsPrevius').show()
                        }else{$('#idPagerModalNotificationsPrevius').hide()}

                        $('#modalApp').modal({
                        })
                    }
                }

            }).fail(function( response ) {

            });

        },

        loadPage : function(page){

            var self = this;
            var json = $.ajax({
                url : "/rest/notifications/my/"+page,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                self.model = response;
                if(response.state == "OK"){

                    if(response.list != null){
                        self.printList(response.list,$('#modalApp').find('.modal-body:first').find('div:first'));

                        if(response.currentPage == (response.nPages-1)){
                            $('#idPagerModalNotificationsNext').hide()
                        }else{$('#idPagerModalNotificationsNext').show()}

                        if(response.currentPage > 0){
                            $('#idPagerModalNotificationsPrevius').show()
                        }else{$('#idPagerModalNotificationsPrevius').hide()}
                    }
                }

            }).fail(function( response ) {

            });

        },

        PreviusPage : function(){
            var page = this.model.currentPage;

            if(page > 0){
                this.loadPage(page - 1)
            }

        },
        NextPage : function(){
            var page = this.model.currentPage;
            this.loadPage(page + 1)
        }
    });

    return vNotifications;

});