/**
 * Created by marc on 31/03/14.
 */

define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'views/vVar',
    'models/mVar',
    'text!../../templates/profile/tProfile.html',
    'views/post/vTextBoxPost',
    'views/post/vPublicaciones',
    'views/profile/vInfoUser',
    'models/mTextBox',
    'models/mPublicaciones',
    'text!../../templates/follow/buttonFollow.html',
    'views/utils/vModalList',
    'views/utils/vVarTime'
], function($, _, Backbone,Bootstrap,vVar,mVar,tProfile,vTextBoxPost,vPublicaciones,vInfoUser,
            mTextBox,mPublicaciones,buttonFollow,vModalList,vVarTime){

    var vProfile = Backbone.View.extend({

        el: $('#contextApp'),

        events: {
        },

        defaults :{
        },

        initialize : function(){
            this.$el.html("");

            try{
                $('#modalApp').modal('hide');
            }catch(err) {

            }

        },

        render: function(id){
            this.$el.html("");
            var compiledTemplate = _.template( tProfile, {} );
            this.$el.append( compiledTemplate );

            var vvar = new vVar();
                vvar.render();

            this.$el.find('#idDivProfilePublicaciones').hide();

            this.init(id);
        },

        init : function(id){

            var url = "/rest/infouser/my";
            if(id != null){
                   url = "/rest/infouser/user/"+id;
            }
            var self = this;

            var vartime1 = new vVarTime();
            vartime1.render(50);

            var friendsJNSON = $.ajax({
                url : "rest/friend/"+id,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime1.quit();

                var friends = response;


                var vartime = new vVarTime();
                vartime.render();

                var json = $.ajax({
                    url : url,
                    type : "GET",
                    dataType : "json"
                }).done(function( response, status, jqXHR ) {
                    vartime.quit();

                    if(response.state == "OK"){

                        self.model = response;

                        //Init InfoUser
                        var _infoUser = new vInfoUser({ el : $("#iddivProfileInfoUser"),model: response});
                        _infoUser.render(friends.relation);

                        if(friends.relation == "OWN"){
                            var _aEditar = self.$el.find('#idDivProfileInfoGeneral').find('a:last');
                            _aEditar.attr('href', '#edit');

                        }else{
                            var _aEditar = self.$el.find('#idDivProfileInfoGeneral').find('a:last');
                            _aEditar.remove();
                        }

                        //idDivProfileTextPost
                        var idUser = response.user.id;
                        var idCurrentUser = response.idcurrent;

                        var userName = response.user.name +" "+response.user.secondname;
                        $('#idDivProfileUserName').html(userName);

                        var src = "";
                        var _img = self.$el.find('img:last');

                        if(response.user.img != null){
                            src =  "data:image/png;base64,"+response.user.img;
                        }else{
                            if(src == ""){
                                src = "/img/defould.png";
                            }
                        }

                        _img.attr('src', src);

                        var cw = _img.width();
                        _img.css({'height':cw+'px'});

                        var _divDescription = self.$el.find("#idDivProfileDescription");
                        _divDescription.html(response.user.description);

                        // PUT FOLLOWERS INFORMATION
                        var _divFollowes = self.$el.find('#idDivProfileFollows');

                        var followers = _divFollowes.find('.blockFollow:eq(0)')
                            .find('div:eq(1)').find('button:last').html(response.user.nfollowers);

                        var follow =_divFollowes.find('.blockFollow:eq(1)')
                            .find('div:eq(1)').find('button:last').html(response.user.nfollow);

                        var npost =_divFollowes.find('.blockFollow:eq(2)')
                            .find('div:eq(1)').find('button:last').html(response.user.npost);

                        var nGrupFav =_divFollowes.find('.blockFollow:eq(3)')
                            .find('div:eq(1)').find('button:last').html(response.user.nFavGrup);

                        nGrupFav.click(function(){
                            self.showFavGrups();
                        });

                        followers.click(function(){
                            self.showfollowers();
                        });

                        follow.click(function(){
                            self.showfollows();
                        });

                        npost.click(function(){
                            self.showPost();
                        });


                        if(friends.relation == "OWN" || friends.relation =="FRIEND"){


                            self.$el.find('#idDivProfilePublicaciones').show();

                            var _publicaciones = new vPublicaciones({
                                el : $("#idDivProfilePrincipalPublicaciones"),
                                model: response});

                            _publicaciones.render();

                            var textBoxPost = new vTextBoxPost({
                                el: $('#IdDivPublicacionsTextBoxUser'),
                                model : response});

                            textBoxPost.render(_publicaciones);

                           self.rederForFriend(response.idcurrent,response.user,friends);


                        }else{
                            var compiledTemplate = _.template( buttonFollow, {text:"SEGUIR"} );
                            self.$el.find('#iddivButtonsPortada').prepend(compiledTemplate);
                            var _btnSeguir = self.$el.find('#iddivButtonsPortada').find('button:first');

                            _btnSeguir.removeClass('buttonFollow');
                            _btnSeguir.addClass('buttonFollow2');
                            _btnSeguir.click(function(){

                                var friendsJNSON = $.ajax({
                                    url : "rest/friend",
                                    type : "POST",
                                    dataType : "json",
                                    data : {
                                        id : idUser
                                    }
                                }).done(function( item, status, jqXHR ){

                                    if(item.state == "OK"){

                                        if(item.relation == "FRIEND"){
                                            _btnSeguir.remove();
                                            self.render(item.userFriend.id);
                                        }
                                    }
                                }).fail(function(response){

                                });
                            });

                        }
                    }else{
                        window.location.href = "/#login";
                    }

                }).fail(function( response ) {
                    vartime.quit();

                });
            }).fail(function(response){
                vartime.quit();

            });
        },


        rederForFriend:function(idcurrent,user,friends){

            var idUser = user.id;
            var self = this;

            if(friends.relation =="FRIEND"){
                var compiledTemplate = _.template( buttonFollow, {text:"SEGUINT"} );
                this.$el.find('#iddivButtonsPortada').prepend(compiledTemplate);
                var _btnSeguir = this.$el.find('#iddivButtonsPortada').find('button:first');

                _btnSeguir.hover(
                    function() {
                        $(this).html('NO SEGUIR')
                    }, function() {
                        $(this ).html("SEGUINT");
                    }
                );

                _btnSeguir.click(function(){

                    var vartime = new vVarTime();
                    vartime.render();
                    var friendsJNSON = $.ajax({
                        url : "rest/friend/update",
                        type : "PUT",
                        dataType : "json",
                        data : {
                            id : idUser,
                            friend : false
                        }
                    }).done(function(item, status, jqXHR){
                        vartime.quit();

                        if(item.state == "OK"){

                            if(item.relation == "NO_FRIEND"){
                                _btnSeguir.remove();
                                self.render(item.userFriend.id);
                            }
                        }
                    }).fail(function(response){
                        vartime.quit();

                    });
                });
            }

        },

        showfollowers : function(){

            var self = this;

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/friend/followers/"+ self.model.user.id,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();
                if(response.state == "OK"){
                    var modalList = new vModalList();
                    modalList.render(response.list,"Seguidors de "+self.model.user.name);
                }

            }).fail(function( response ) {
                vartime.quit();


            });
        },

        showfollows : function(){
            var self = this;

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/friend/follows/"+ self.model.user.id,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();
                if(response.state == "OK"){
                    var modalList = new vModalList();
                    modalList.render(response.list,"Seguits per "+self.model.user.name);
                }

            }).fail(function( response ) {
                vartime.quit();


            });
        },

        showPost : function(){

            var self = this;

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/post/"+ self.model.user.id,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();

                if(response.state == "OK"){
                    var modalList = new vModalList();
                    modalList.render(response.list,"Publicacions de" +self.model.user.name);
                }

            }).fail(function( response ) {
                vartime.quit();
            });
        },

        showFavGrups : function(){

            var self = this;

            var vartime = new vVarTime();
            vartime.render();
            var json = $.ajax({
                url : "/rest/grup/favourites/"+ self.model.user.id,
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {
                vartime.quit();
                if(response.state == "OK"){
                    var modalList = new vModalList();
                    modalList.render(response.list,"Grups favorits de " +self.model.user.name);
                }
            }).fail(function( response ) {
                vartime.quit();
            });

        }

    });


    return vProfile;
});
