/**
 * Created by marc on 30/03/14.
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'bootstrap',
    'models/mVar',
    'text!../../templates/var/tVar.html'
], function($, _, Backbone,Bootstrap,mVar,tVar){

    var vVar = Backbone.View.extend({

        el: $('#varApp'),

        events: {
            "click #idVarBtnHome": "goHome",
            "click #idVarBtnNameUser": "goPerfil",
            "click #idVarBtnCloseSession": "closeSession",
            "keypress #idVarInputSearch": "searchKeyPress",
            "click #idVarSpanSearch": "search",
            "click #idBtnVarEdit": "goEdit"
        },

        initialize : function(){
        },

        render : function(){
            this.$el.html("");

            this.model = new mVar();

            var compiledTemplate = _.template( tVar, {name : "Cuenta"} );
            this.$el.append( compiledTemplate );

            this.$el.find('#idVarBtnNotificaciones').hide();
            this.$el.find('#idVarBtnNotificaciones').html("");

            this.init();
        },

        init : function(){

            var self = this;
            var json = $.ajax({
                url : "/rest/user/infoLite",
                type : "GET",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                if(response.state == "OK"){

                    self.$el.find('#idVarBtnNameUser').html(response.name +" "+ response.secondname);

                    if(response.grups == null || response.grups.length == 0){
                        self.$el.find('#idVarBtnDropDown').hide();
                        self.$el.find('#idVarUlDropDown').hide();
                    }else{

                        for(var i in response.grups){

                            var id = response.grups[i].id;
                            var name = response.grups[i].name;
                            var div = '<li><a href="#group/'+ id +'">'+ name +'</a></li>';

                            self.$el.find('#idVarUlDropDown').append(div);
                        }
                    }

                    //idVarBtnDropDown
                    //idVarUlDropDown
                    //<li><a href="#">Action</a></li>

                    self.model.contruct(response.notification,
                        response.name +" "+ response.secondname,
                        response.idcurrent);

                    if(response.notification > 0){
                        self.$el.find('#idVarBtnNotificaciones').show();
                        self.$el.find('#idVarBtnNotificaciones').html(response.notification);
                    }else{
                        self.$el.find('#idVarBtnNotificaciones').hide();
                        self.$el.find('#idVarBtnNotificaciones').html("");
                    }

                }else{
                    //self.$el.hide();
                }


            }).fail(function( response ) {

            });
        },

        isEmpty :function(){

            return this.$el.html() == "" ? true : false;
        },

        goHome : function(){
            window.location.href = "/#my";
        },
        goEdit : function(){
            window.location.href = "/#edit";
        },

        goPerfil : function(){

            window.location.href = "/#profile/"+this.model.userId;
        },

        setModel :function(model){this.model = model;},

        closeSession : function(){
            var json = $.ajax({
                url : "/rest/auth/logout",
                //contentType: 'application/json',
                type : "POST",
                dataType : "json"
            }).done(function( response, status, jqXHR ) {

                window.location.href = "/#login";
            }).fail(function( response ) {

                window.location.href = "/#login";

            });
        },

        searchKeyPress : function(event){

            if ( event.which == 13 ) {
                this.search();
            }

        },

        search : function(){

            var text = this.$el.find('#idVarInputSearch').val();

            if(text.length >=3){
                window.location.href = "/#search/"+text;
            }

        }
    });

    return vVar;

});
